from asdl import pybase
from pylib.collections_ import OrderedDict
from typing import Optional, List, Tuple, Dict, Any, cast, TYPE_CHECKING

from _devbuild.gen.id_kind_asdl import Id_t
from _devbuild.gen.id_kind_asdl import Id_str


from asdl import runtime  # For runtime.NO_SPID
from asdl.runtime import NewRecord, NewLeaf
from _devbuild.gen.hnode_asdl import color_e, hnode, hnode_e, hnode_t, field

class parse_result_e(object):
  EmptyLine = 1
  Eof = 2
  Node = 3

_parse_result_str = {
  1: 'parse_result.EmptyLine',
  2: 'parse_result.Eof',
  3: 'parse_result.Node',
}

def parse_result_str(tag):
  # type: (int) -> str
  return _parse_result_str[tag]

class parse_result_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class parse_result__EmptyLine(parse_result_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.EmptyLine')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.EmptyLine')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class parse_result__Eof(parse_result_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.Eof')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.Eof')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class parse_result__Node(parse_result_t):
  _type_tag = 3
  __slots__ = ('cmd',)

  def __init__(self, cmd):
    # type: (Optional[command_t]) -> None
    self.cmd = cmd

  @staticmethod
  def Create():
    # type: () -> parse_result__Node
    return parse_result__Node(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.Node')
    L = out_node.fields

    assert self.cmd is not None
    x0 = self.cmd.PrettyTree()
    L.append(field('cmd', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result.Node')
    L = out_node.fields
    assert self.cmd is not None
    x0 = self.cmd.AbbreviatedTree()
    L.append(field('cmd', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class parse_result(object):
  EmptyLine = parse_result__EmptyLine
  Eof = parse_result__Eof
  Node = parse_result__Node

class source_e(object):
  Interactive = 1
  Headless = 2
  Unused = 3
  CFlag = 4
  Stdin = 5
  MainFile = 6
  SourcedFile = 7
  ArgvWord = 8
  Variable = 9
  VarRef = 10
  Alias = 11
  Reparsed = 12
  Synthetic = 13

_source_str = {
  1: 'source.Interactive',
  2: 'source.Headless',
  3: 'source.Unused',
  4: 'source.CFlag',
  5: 'source.Stdin',
  6: 'source.MainFile',
  7: 'source.SourcedFile',
  8: 'source.ArgvWord',
  9: 'source.Variable',
  10: 'source.VarRef',
  11: 'source.Alias',
  12: 'source.Reparsed',
  13: 'source.Synthetic',
}

def source_str(tag):
  # type: (int) -> str
  return _source_str[tag]

class source_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class source__Interactive(source_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Interactive')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Interactive')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Headless(source_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Headless')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Headless')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Unused(source_t):
  _type_tag = 3
  __slots__ = ('comment',)

  def __init__(self, comment):
    # type: (str) -> None
    self.comment = comment

  @staticmethod
  def Create():
    # type: () -> source__Unused
    return source__Unused('')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Unused')
    L = out_node.fields

    x0 = NewLeaf(self.comment, color_e.StringConst)
    L.append(field('comment', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Unused')
    L = out_node.fields
    x0 = NewLeaf(self.comment, color_e.StringConst)
    L.append(field('comment', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__CFlag(source_t):
  _type_tag = 4
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.CFlag')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.CFlag')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Stdin(source_t):
  _type_tag = 5
  __slots__ = ('comment',)

  def __init__(self, comment):
    # type: (str) -> None
    self.comment = comment

  @staticmethod
  def Create():
    # type: () -> source__Stdin
    return source__Stdin('')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Stdin')
    L = out_node.fields

    x0 = NewLeaf(self.comment, color_e.StringConst)
    L.append(field('comment', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Stdin')
    L = out_node.fields
    x0 = NewLeaf(self.comment, color_e.StringConst)
    L.append(field('comment', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__MainFile(source_t):
  _type_tag = 6
  __slots__ = ('path',)

  def __init__(self, path):
    # type: (str) -> None
    self.path = path

  @staticmethod
  def Create():
    # type: () -> source__MainFile
    return source__MainFile('')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.MainFile')
    L = out_node.fields

    x0 = NewLeaf(self.path, color_e.StringConst)
    L.append(field('path', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.MainFile')
    L = out_node.fields
    x0 = NewLeaf(self.path, color_e.StringConst)
    L.append(field('path', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__SourcedFile(source_t):
  _type_tag = 7
  __slots__ = ('path', 'spid')

  def __init__(self, path, spid):
    # type: (str, int) -> None
    self.path = path
    self.spid = spid

  @staticmethod
  def Create():
    # type: () -> source__SourcedFile
    return source__SourcedFile('', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.SourcedFile')
    L = out_node.fields

    x0 = NewLeaf(self.path, color_e.StringConst)
    L.append(field('path', x0))

    x1 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.SourcedFile')
    L = out_node.fields
    x0 = NewLeaf(self.path, color_e.StringConst)
    L.append(field('path', x0))

    x1 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__ArgvWord(source_t):
  _type_tag = 8
  __slots__ = ('what', 'span_id')

  def __init__(self, what, span_id):
    # type: (str, int) -> None
    self.what = what
    self.span_id = span_id

  @staticmethod
  def Create():
    # type: () -> source__ArgvWord
    return source__ArgvWord('', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.ArgvWord')
    L = out_node.fields

    x0 = NewLeaf(self.what, color_e.StringConst)
    L.append(field('what', x0))

    x1 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.ArgvWord')
    L = out_node.fields
    x0 = NewLeaf(self.what, color_e.StringConst)
    L.append(field('what', x0))

    x1 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Variable(source_t):
  _type_tag = 9
  __slots__ = ('var_name', 'span_id')

  def __init__(self, var_name, span_id):
    # type: (str, int) -> None
    self.var_name = var_name
    self.span_id = span_id

  @staticmethod
  def Create():
    # type: () -> source__Variable
    return source__Variable('', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Variable')
    L = out_node.fields

    x0 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x0))

    x1 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Variable')
    L = out_node.fields
    x0 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x0))

    x1 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__VarRef(source_t):
  _type_tag = 10
  __slots__ = ('orig_tok',)

  def __init__(self, orig_tok):
    # type: (Optional[Token]) -> None
    self.orig_tok = orig_tok

  @staticmethod
  def Create():
    # type: () -> source__VarRef
    return source__VarRef(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.VarRef')
    L = out_node.fields

    assert self.orig_tok is not None
    x0 = self.orig_tok.PrettyTree()
    L.append(field('orig_tok', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.VarRef')
    L = out_node.fields
    assert self.orig_tok is not None
    x0 = self.orig_tok.AbbreviatedTree()
    L.append(field('orig_tok', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Alias(source_t):
  _type_tag = 11
  __slots__ = ('argv0', 'argv0_spid')

  def __init__(self, argv0, argv0_spid):
    # type: (str, int) -> None
    self.argv0 = argv0
    self.argv0_spid = argv0_spid

  @staticmethod
  def Create():
    # type: () -> source__Alias
    return source__Alias('', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Alias')
    L = out_node.fields

    x0 = NewLeaf(self.argv0, color_e.StringConst)
    L.append(field('argv0', x0))

    x1 = hnode.Leaf(str(self.argv0_spid), color_e.OtherConst)
    L.append(field('argv0_spid', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Alias')
    L = out_node.fields
    x0 = NewLeaf(self.argv0, color_e.StringConst)
    L.append(field('argv0', x0))

    x1 = hnode.Leaf(str(self.argv0_spid), color_e.OtherConst)
    L.append(field('argv0_spid', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Reparsed(source_t):
  _type_tag = 12
  __slots__ = ('what', 'left_token', 'right_token')

  def __init__(self, what, left_token, right_token):
    # type: (str, Optional[Token], Optional[Token]) -> None
    self.what = what
    self.left_token = left_token
    self.right_token = right_token

  @staticmethod
  def Create():
    # type: () -> source__Reparsed
    return source__Reparsed('', None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Reparsed')
    L = out_node.fields

    x0 = NewLeaf(self.what, color_e.StringConst)
    L.append(field('what', x0))

    assert self.left_token is not None
    x1 = self.left_token.PrettyTree()
    L.append(field('left_token', x1))

    assert self.right_token is not None
    x2 = self.right_token.PrettyTree()
    L.append(field('right_token', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Reparsed')
    L = out_node.fields
    x0 = NewLeaf(self.what, color_e.StringConst)
    L.append(field('what', x0))

    assert self.left_token is not None
    x1 = self.left_token.AbbreviatedTree()
    L.append(field('left_token', x1))

    assert self.right_token is not None
    x2 = self.right_token.AbbreviatedTree()
    L.append(field('right_token', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Synthetic(source_t):
  _type_tag = 13
  __slots__ = ('s',)

  def __init__(self, s):
    # type: (str) -> None
    self.s = s

  @staticmethod
  def Create():
    # type: () -> source__Synthetic
    return source__Synthetic('')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Synthetic')
    L = out_node.fields

    x0 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source.Synthetic')
    L = out_node.fields
    x0 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source(object):
  Interactive = source__Interactive
  Headless = source__Headless
  Unused = source__Unused
  CFlag = source__CFlag
  Stdin = source__Stdin
  MainFile = source__MainFile
  SourcedFile = source__SourcedFile
  ArgvWord = source__ArgvWord
  Variable = source__Variable
  VarRef = source__VarRef
  Alias = source__Alias
  Reparsed = source__Reparsed
  Synthetic = source__Synthetic

class loc_e(object):
  Missing = 1
  Span = 2
  Token = 66
  WordPart = 4
  Word = 5
  Arith = 6
  Command = 7

_loc_str = {
  1: 'loc.Missing',
  2: 'loc.Span',
  4: 'loc.WordPart',
  5: 'loc.Word',
  6: 'loc.Arith',
  7: 'loc.Command',
  66: 'loc.Token',
}

def loc_str(tag):
  # type: (int) -> str
  return _loc_str[tag]

class loc_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class loc__Missing(loc_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Missing')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Missing')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc__Span(loc_t):
  _type_tag = 2
  __slots__ = ('span_id',)

  def __init__(self, span_id):
    # type: (int) -> None
    self.span_id = span_id

  @staticmethod
  def Create():
    # type: () -> loc__Span
    return loc__Span(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Span')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Span')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc__WordPart(loc_t):
  _type_tag = 4
  __slots__ = ('p',)

  def __init__(self, p):
    # type: (Optional[word_part_t]) -> None
    self.p = p

  @staticmethod
  def Create():
    # type: () -> loc__WordPart
    return loc__WordPart(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.WordPart')
    L = out_node.fields

    assert self.p is not None
    x0 = self.p.PrettyTree()
    L.append(field('p', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.WordPart')
    L = out_node.fields
    assert self.p is not None
    x0 = self.p.AbbreviatedTree()
    L.append(field('p', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc__Word(loc_t):
  _type_tag = 5
  __slots__ = ('w',)

  def __init__(self, w):
    # type: (Optional[word_t]) -> None
    self.w = w

  @staticmethod
  def Create():
    # type: () -> loc__Word
    return loc__Word(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Word')
    L = out_node.fields

    assert self.w is not None
    x0 = self.w.PrettyTree()
    L.append(field('w', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Word')
    L = out_node.fields
    assert self.w is not None
    x0 = self.w.AbbreviatedTree()
    L.append(field('w', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc__Arith(loc_t):
  _type_tag = 6
  __slots__ = ('a',)

  def __init__(self, a):
    # type: (Optional[arith_expr_t]) -> None
    self.a = a

  @staticmethod
  def Create():
    # type: () -> loc__Arith
    return loc__Arith(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Arith')
    L = out_node.fields

    assert self.a is not None
    x0 = self.a.PrettyTree()
    L.append(field('a', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Arith')
    L = out_node.fields
    assert self.a is not None
    x0 = self.a.AbbreviatedTree()
    L.append(field('a', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc__Command(loc_t):
  _type_tag = 7
  __slots__ = ('c',)

  def __init__(self, c):
    # type: (Optional[command_t]) -> None
    self.c = c

  @staticmethod
  def Create():
    # type: () -> loc__Command
    return loc__Command(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Command')
    L = out_node.fields

    assert self.c is not None
    x0 = self.c.PrettyTree()
    L.append(field('c', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc.Command')
    L = out_node.fields
    assert self.c is not None
    x0 = self.c.AbbreviatedTree()
    L.append(field('c', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc(object):
  Missing = loc__Missing
  Span = loc__Span
  WordPart = loc__WordPart
  Word = loc__Word
  Arith = loc__Arith
  Command = loc__Command

class bracket_op_e(object):
  WholeArray = 1
  ArrayIndex = 2

_bracket_op_str = {
  1: 'bracket_op.WholeArray',
  2: 'bracket_op.ArrayIndex',
}

def bracket_op_str(tag):
  # type: (int) -> str
  return _bracket_op_str[tag]

class bracket_op_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class bracket_op__WholeArray(bracket_op_t):
  _type_tag = 1
  __slots__ = ('op_id',)

  def __init__(self, op_id):
    # type: (Id_t) -> None
    self.op_id = op_id

  @staticmethod
  def Create():
    # type: () -> bracket_op__WholeArray
    return bracket_op__WholeArray(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bracket_op.WholeArray')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bracket_op.WholeArray')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bracket_op__ArrayIndex(bracket_op_t):
  _type_tag = 2
  __slots__ = ('expr',)

  def __init__(self, expr):
    # type: (Optional[arith_expr_t]) -> None
    self.expr = expr

  @staticmethod
  def Create():
    # type: () -> bracket_op__ArrayIndex
    return bracket_op__ArrayIndex(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bracket_op.ArrayIndex')
    L = out_node.fields

    assert self.expr is not None
    x0 = self.expr.PrettyTree()
    L.append(field('expr', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bracket_op.ArrayIndex')
    L = out_node.fields
    assert self.expr is not None
    x0 = self.expr.AbbreviatedTree()
    L.append(field('expr', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bracket_op(object):
  WholeArray = bracket_op__WholeArray
  ArrayIndex = bracket_op__ArrayIndex

class suffix_op_e(object):
  Nullary = 66
  Unary = 2
  Static = 3
  PatSub = 4
  Slice = 5

_suffix_op_str = {
  2: 'suffix_op.Unary',
  3: 'suffix_op.Static',
  4: 'suffix_op.PatSub',
  5: 'suffix_op.Slice',
  66: 'suffix_op.Nullary',
}

def suffix_op_str(tag):
  # type: (int) -> str
  return _suffix_op_str[tag]

class suffix_op_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class suffix_op__Unary(suffix_op_t):
  _type_tag = 2
  __slots__ = ('op', 'arg_word')

  def __init__(self, op, arg_word):
    # type: (Optional[Token], Optional[rhs_word_t]) -> None
    self.op = op
    self.arg_word = arg_word

  @staticmethod
  def Create():
    # type: () -> suffix_op__Unary
    return suffix_op__Unary(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Unary')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    assert self.arg_word is not None
    x1 = self.arg_word.PrettyTree()
    L.append(field('arg_word', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Unary')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    assert self.arg_word is not None
    x1 = self.arg_word.AbbreviatedTree()
    L.append(field('arg_word', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class suffix_op__Static(suffix_op_t):
  _type_tag = 3
  __slots__ = ('tok', 'arg')

  def __init__(self, tok, arg):
    # type: (Optional[Token], str) -> None
    self.tok = tok
    self.arg = arg

  @staticmethod
  def Create():
    # type: () -> suffix_op__Static
    return suffix_op__Static(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Static')
    L = out_node.fields

    assert self.tok is not None
    x0 = self.tok.PrettyTree()
    L.append(field('tok', x0))

    x1 = NewLeaf(self.arg, color_e.StringConst)
    L.append(field('arg', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Static')
    L = out_node.fields
    assert self.tok is not None
    x0 = self.tok.AbbreviatedTree()
    L.append(field('tok', x0))

    x1 = NewLeaf(self.arg, color_e.StringConst)
    L.append(field('arg', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class suffix_op__PatSub(suffix_op_t):
  _type_tag = 4
  __slots__ = ('pat', 'replace', 'replace_mode', 'slash_tok')

  def __init__(self, pat, replace, replace_mode, slash_tok):
    # type: (Optional[compound_word], Optional[rhs_word_t], Id_t, Optional[Token]) -> None
    self.pat = pat
    self.replace = replace
    self.replace_mode = replace_mode
    self.slash_tok = slash_tok

  @staticmethod
  def Create():
    # type: () -> suffix_op__PatSub
    return suffix_op__PatSub(None, None, -1, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.PatSub')
    L = out_node.fields

    assert self.pat is not None
    x0 = self.pat.PrettyTree()
    L.append(field('pat', x0))

    assert self.replace is not None
    x1 = self.replace.PrettyTree()
    L.append(field('replace', x1))

    x2 = hnode.Leaf(Id_str(self.replace_mode), color_e.UserType)
    L.append(field('replace_mode', x2))

    assert self.slash_tok is not None
    x3 = self.slash_tok.PrettyTree()
    L.append(field('slash_tok', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.PatSub')
    L = out_node.fields
    assert self.pat is not None
    x0 = self.pat.AbbreviatedTree()
    L.append(field('pat', x0))

    assert self.replace is not None
    x1 = self.replace.AbbreviatedTree()
    L.append(field('replace', x1))

    x2 = hnode.Leaf(Id_str(self.replace_mode), color_e.UserType)
    L.append(field('replace_mode', x2))

    assert self.slash_tok is not None
    x3 = self.slash_tok.AbbreviatedTree()
    L.append(field('slash_tok', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class suffix_op__Slice(suffix_op_t):
  _type_tag = 5
  __slots__ = ('begin', 'length')

  def __init__(self, begin, length):
    # type: (Optional[Optional[arith_expr_t]], Optional[Optional[arith_expr_t]]) -> None
    self.begin = begin
    self.length = length

  @staticmethod
  def Create():
    # type: () -> suffix_op__Slice
    return suffix_op__Slice(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Slice')
    L = out_node.fields

    if self.begin is not None:  # maybe
      x0 = self.begin.PrettyTree()
      L.append(field('begin', x0))

    if self.length is not None:  # maybe
      x1 = self.length.PrettyTree()
      L.append(field('length', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('suffix_op.Slice')
    L = out_node.fields
    if self.begin is not None:  # maybe
      x0 = self.begin.AbbreviatedTree()
      L.append(field('begin', x0))

    if self.length is not None:  # maybe
      x1 = self.length.AbbreviatedTree()
      L.append(field('length', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class suffix_op(object):
  Unary = suffix_op__Unary
  Static = suffix_op__Static
  PatSub = suffix_op__PatSub
  Slice = suffix_op__Slice

class word_part_e(object):
  ShArrayLiteral = 72
  AssocArrayLiteral = 2
  Literal = 66
  EscapedLiteral = 4
  SingleQuoted = 69
  DoubleQuoted = 68
  SimpleVarSub = 70
  BracedVarSub = 67
  CommandSub = 71
  TildeSub = 10
  ArithSub = 11
  BracedTuple = 12
  BracedRange = 13
  ExtGlob = 14
  Splice = 15
  FuncCall = 16
  ExprSub = 17

_word_part_str = {
  2: 'word_part.AssocArrayLiteral',
  4: 'word_part.EscapedLiteral',
  10: 'word_part.TildeSub',
  11: 'word_part.ArithSub',
  12: 'word_part.BracedTuple',
  13: 'word_part.BracedRange',
  14: 'word_part.ExtGlob',
  15: 'word_part.Splice',
  16: 'word_part.FuncCall',
  17: 'word_part.ExprSub',
  66: 'word_part.Literal',
  67: 'word_part.BracedVarSub',
  68: 'word_part.DoubleQuoted',
  69: 'word_part.SingleQuoted',
  70: 'word_part.SimpleVarSub',
  71: 'word_part.CommandSub',
  72: 'word_part.ShArrayLiteral',
}

def word_part_str(tag):
  # type: (int) -> str
  return _word_part_str[tag]

class word_part_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class word_part__AssocArrayLiteral(word_part_t):
  _type_tag = 2
  __slots__ = ('left', 'pairs', 'spids')

  def __init__(self, left, pairs, spids=None):
    # type: (Optional[Token], Optional[List[assoc_pair]], Optional[List[int]]) -> None
    self.left = left
    self.pairs = pairs
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__AssocArrayLiteral
    return word_part__AssocArrayLiteral(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.AssocArrayLiteral')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.pairs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.pairs:
        x1.children.append(i1.PrettyTree())
      L.append(field('pairs', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.AssocArrayLiteral')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.pairs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.pairs:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('pairs', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__EscapedLiteral(word_part_t):
  _type_tag = 4
  __slots__ = ('token', 'ch', 'spids')

  def __init__(self, token, ch, spids=None):
    # type: (Optional[Token], str, Optional[List[int]]) -> None
    self.token = token
    self.ch = ch
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__EscapedLiteral
    return word_part__EscapedLiteral(None, '', [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.EscapedLiteral')
    L = out_node.fields

    assert self.token is not None
    x0 = self.token.PrettyTree()
    L.append(field('token', x0))

    x1 = NewLeaf(self.ch, color_e.StringConst)
    L.append(field('ch', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.EscapedLiteral')
    L = out_node.fields
    assert self.token is not None
    x0 = self.token.AbbreviatedTree()
    L.append(field('token', x0))

    x1 = NewLeaf(self.ch, color_e.StringConst)
    L.append(field('ch', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__TildeSub(word_part_t):
  _type_tag = 10
  __slots__ = ('token', 'user_name', 'spids')

  def __init__(self, token, user_name, spids=None):
    # type: (Optional[Token], Optional[Optional[str]], Optional[List[int]]) -> None
    self.token = token
    self.user_name = user_name
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__TildeSub
    return word_part__TildeSub(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.TildeSub')
    L = out_node.fields

    assert self.token is not None
    x0 = self.token.PrettyTree()
    L.append(field('token', x0))

    if self.user_name is not None:  # maybe
      x1 = NewLeaf(self.user_name, color_e.StringConst)
      L.append(field('user_name', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.TildeSub')
    L = out_node.fields
    assert self.token is not None
    x0 = self.token.AbbreviatedTree()
    L.append(field('token', x0))

    if self.user_name is not None:  # maybe
      x1 = NewLeaf(self.user_name, color_e.StringConst)
      L.append(field('user_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__ArithSub(word_part_t):
  _type_tag = 11
  __slots__ = ('anode', 'spids')

  def __init__(self, anode, spids=None):
    # type: (Optional[arith_expr_t], Optional[List[int]]) -> None
    self.anode = anode
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__ArithSub
    return word_part__ArithSub(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ArithSub')
    L = out_node.fields

    assert self.anode is not None
    x0 = self.anode.PrettyTree()
    L.append(field('anode', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ArithSub')
    L = out_node.fields
    assert self.anode is not None
    x0 = self.anode.AbbreviatedTree()
    L.append(field('anode', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__BracedTuple(word_part_t):
  _type_tag = 12
  __slots__ = ('words', 'spids')

  def __init__(self, words, spids=None):
    # type: (Optional[List[compound_word]], Optional[List[int]]) -> None
    self.words = words
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__BracedTuple
    return word_part__BracedTuple([], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.BracedTuple')
    L = out_node.fields

    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.PrettyTree())
      L.append(field('words', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.BracedTuple')
    L = out_node.fields
    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('words', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__BracedRange(word_part_t):
  _type_tag = 13
  __slots__ = ('kind', 'start', 'end', 'step', 'spids')

  def __init__(self, kind, start, end, step, spids=None):
    # type: (Id_t, str, str, int, Optional[List[int]]) -> None
    self.kind = kind
    self.start = start
    self.end = end
    self.step = step
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__BracedRange
    return word_part__BracedRange(-1, '', '', -1, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.BracedRange')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.kind), color_e.UserType)
    L.append(field('kind', x0))

    x1 = NewLeaf(self.start, color_e.StringConst)
    L.append(field('start', x1))

    x2 = NewLeaf(self.end, color_e.StringConst)
    L.append(field('end', x2))

    x3 = hnode.Leaf(str(self.step), color_e.OtherConst)
    L.append(field('step', x3))

    if self.spids is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(field('spids', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.BracedRange')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.kind), color_e.UserType)
    L.append(field('kind', x0))

    x1 = NewLeaf(self.start, color_e.StringConst)
    L.append(field('start', x1))

    x2 = NewLeaf(self.end, color_e.StringConst)
    L.append(field('end', x2))

    x3 = hnode.Leaf(str(self.step), color_e.OtherConst)
    L.append(field('step', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__ExtGlob(word_part_t):
  _type_tag = 14
  __slots__ = ('op', 'arms', 'spids')

  def __init__(self, op, arms, spids=None):
    # type: (Optional[Token], Optional[List[compound_word]], Optional[List[int]]) -> None
    self.op = op
    self.arms = arms
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__ExtGlob
    return word_part__ExtGlob(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ExtGlob')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    if self.arms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.arms:
        x1.children.append(i1.PrettyTree())
      L.append(field('arms', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ExtGlob')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    if self.arms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.arms:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('arms', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__Splice(word_part_t):
  _type_tag = 15
  __slots__ = ('name', 'var_name', 'spids')

  def __init__(self, name, var_name, spids=None):
    # type: (Optional[Token], str, Optional[List[int]]) -> None
    self.name = name
    self.var_name = var_name
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__Splice
    return word_part__Splice(None, '', [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.Splice')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.Splice')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__FuncCall(word_part_t):
  _type_tag = 16
  __slots__ = ('name', 'args', 'spids')

  def __init__(self, name, args, spids=None):
    # type: (Optional[Token], Optional[ArgList], Optional[List[int]]) -> None
    self.name = name
    self.args = args
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__FuncCall
    return word_part__FuncCall(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.FuncCall')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    assert self.args is not None
    x1 = self.args.PrettyTree()
    L.append(field('args', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.FuncCall')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    assert self.args is not None
    x1 = self.args.AbbreviatedTree()
    L.append(field('args', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part__ExprSub(word_part_t):
  _type_tag = 17
  __slots__ = ('left', 'child', 'spids')

  def __init__(self, left, child, spids=None):
    # type: (Optional[Token], Optional[expr_t], Optional[List[int]]) -> None
    self.left = left
    self.child = child
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> word_part__ExprSub
    return word_part__ExprSub(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ExprSub')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word_part.ExprSub')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word_part(object):
  AssocArrayLiteral = word_part__AssocArrayLiteral
  EscapedLiteral = word_part__EscapedLiteral
  TildeSub = word_part__TildeSub
  ArithSub = word_part__ArithSub
  BracedTuple = word_part__BracedTuple
  BracedRange = word_part__BracedRange
  ExtGlob = word_part__ExtGlob
  Splice = word_part__Splice
  FuncCall = word_part__FuncCall
  ExprSub = word_part__ExprSub

class rhs_word_e(object):
  Empty = 1
  Compound = 75

_rhs_word_str = {
  1: 'rhs_word.Empty',
  75: 'rhs_word.Compound',
}

def rhs_word_str(tag):
  # type: (int) -> str
  return _rhs_word_str[tag]

class rhs_word_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class rhs_word__Empty(rhs_word_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('rhs_word.Empty')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('rhs_word.Empty')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class rhs_word(object):
  Empty = rhs_word__Empty

class word_e(object):
  Token = 66
  Compound = 75
  BracedTree = 3
  String = 4

_word_str = {
  3: 'word.BracedTree',
  4: 'word.String',
  66: 'word.Token',
  75: 'word.Compound',
}

def word_str(tag):
  # type: (int) -> str
  return _word_str[tag]

class word_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class word__BracedTree(word_t):
  _type_tag = 3
  __slots__ = ('parts',)

  def __init__(self, parts):
    # type: (Optional[List[word_part_t]]) -> None
    self.parts = parts

  @staticmethod
  def Create():
    # type: () -> word__BracedTree
    return word__BracedTree([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word.BracedTree')
    L = out_node.fields

    if self.parts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.PrettyTree())
      L.append(field('parts', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word.BracedTree')
    L = out_node.fields
    if self.parts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('parts', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word__String(word_t):
  _type_tag = 4
  __slots__ = ('id', 's', 'span_id')

  def __init__(self, id, s, span_id):
    # type: (Id_t, str, int) -> None
    self.id = id
    self.s = s
    self.span_id = span_id

  @staticmethod
  def Create():
    # type: () -> word__String
    return word__String(-1, '', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word.String')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x1))

    x2 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('word.String')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x1))

    x2 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class word(object):
  BracedTree = word__BracedTree
  String = word__String

class sh_lhs_expr_e(object):
  Name = 1
  IndexedName = 2
  UnparsedIndex = 3

_sh_lhs_expr_str = {
  1: 'sh_lhs_expr.Name',
  2: 'sh_lhs_expr.IndexedName',
  3: 'sh_lhs_expr.UnparsedIndex',
}

def sh_lhs_expr_str(tag):
  # type: (int) -> str
  return _sh_lhs_expr_str[tag]

class sh_lhs_expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class sh_lhs_expr__Name(sh_lhs_expr_t):
  _type_tag = 1
  __slots__ = ('left', 'name')

  def __init__(self, left, name):
    # type: (Optional[Token], str) -> None
    self.left = left
    self.name = name

  @staticmethod
  def Create():
    # type: () -> sh_lhs_expr__Name
    return sh_lhs_expr__Name(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.Name')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.Name')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class sh_lhs_expr__IndexedName(sh_lhs_expr_t):
  _type_tag = 2
  __slots__ = ('left', 'name', 'index')

  def __init__(self, left, name, index):
    # type: (Optional[Token], str, Optional[arith_expr_t]) -> None
    self.left = left
    self.name = name
    self.index = index

  @staticmethod
  def Create():
    # type: () -> sh_lhs_expr__IndexedName
    return sh_lhs_expr__IndexedName(None, '', None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.IndexedName')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    assert self.index is not None
    x2 = self.index.PrettyTree()
    L.append(field('index', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.IndexedName')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    assert self.index is not None
    x2 = self.index.AbbreviatedTree()
    L.append(field('index', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class sh_lhs_expr__UnparsedIndex(sh_lhs_expr_t):
  _type_tag = 3
  __slots__ = ('left', 'name', 'index')

  def __init__(self, left, name, index):
    # type: (Optional[Token], str, str) -> None
    self.left = left
    self.name = name
    self.index = index

  @staticmethod
  def Create():
    # type: () -> sh_lhs_expr__UnparsedIndex
    return sh_lhs_expr__UnparsedIndex(None, '', '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.UnparsedIndex')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    x2 = NewLeaf(self.index, color_e.StringConst)
    L.append(field('index', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_lhs_expr.UnparsedIndex')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    x2 = NewLeaf(self.index, color_e.StringConst)
    L.append(field('index', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class sh_lhs_expr(object):
  Name = sh_lhs_expr__Name
  IndexedName = sh_lhs_expr__IndexedName
  UnparsedIndex = sh_lhs_expr__UnparsedIndex

class arith_expr_e(object):
  VarSub = 70
  Word = 75
  UnaryAssign = 3
  BinaryAssign = 4
  Unary = 5
  Binary = 6
  TernaryOp = 7

_arith_expr_str = {
  3: 'arith_expr.UnaryAssign',
  4: 'arith_expr.BinaryAssign',
  5: 'arith_expr.Unary',
  6: 'arith_expr.Binary',
  7: 'arith_expr.TernaryOp',
  70: 'arith_expr.VarSub',
  75: 'arith_expr.Word',
}

def arith_expr_str(tag):
  # type: (int) -> str
  return _arith_expr_str[tag]

class arith_expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class arith_expr__UnaryAssign(arith_expr_t):
  _type_tag = 3
  __slots__ = ('op_id', 'child')

  def __init__(self, op_id, child):
    # type: (Id_t, Optional[arith_expr_t]) -> None
    self.op_id = op_id
    self.child = child

  @staticmethod
  def Create():
    # type: () -> arith_expr__UnaryAssign
    return arith_expr__UnaryAssign(-1, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.UnaryAssign')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.UnaryAssign')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class arith_expr__BinaryAssign(arith_expr_t):
  _type_tag = 4
  __slots__ = ('op_id', 'left', 'right')

  def __init__(self, op_id, left, right):
    # type: (Id_t, Optional[arith_expr_t], Optional[arith_expr_t]) -> None
    self.op_id = op_id
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> arith_expr__BinaryAssign
    return arith_expr__BinaryAssign(-1, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.BinaryAssign')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.PrettyTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.BinaryAssign')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.AbbreviatedTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class arith_expr__Unary(arith_expr_t):
  _type_tag = 5
  __slots__ = ('op_id', 'child')

  def __init__(self, op_id, child):
    # type: (Id_t, Optional[arith_expr_t]) -> None
    self.op_id = op_id
    self.child = child

  @staticmethod
  def Create():
    # type: () -> arith_expr__Unary
    return arith_expr__Unary(-1, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.Unary')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.Unary')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class arith_expr__Binary(arith_expr_t):
  _type_tag = 6
  __slots__ = ('op_id', 'left', 'right')

  def __init__(self, op_id, left, right):
    # type: (Id_t, Optional[arith_expr_t], Optional[arith_expr_t]) -> None
    self.op_id = op_id
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> arith_expr__Binary
    return arith_expr__Binary(-1, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.Binary')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.PrettyTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.Binary')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.AbbreviatedTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class arith_expr__TernaryOp(arith_expr_t):
  _type_tag = 7
  __slots__ = ('cond', 'true_expr', 'false_expr')

  def __init__(self, cond, true_expr, false_expr):
    # type: (Optional[arith_expr_t], Optional[arith_expr_t], Optional[arith_expr_t]) -> None
    self.cond = cond
    self.true_expr = true_expr
    self.false_expr = false_expr

  @staticmethod
  def Create():
    # type: () -> arith_expr__TernaryOp
    return arith_expr__TernaryOp(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.TernaryOp')
    L = out_node.fields

    assert self.cond is not None
    x0 = self.cond.PrettyTree()
    L.append(field('cond', x0))

    assert self.true_expr is not None
    x1 = self.true_expr.PrettyTree()
    L.append(field('true_expr', x1))

    assert self.false_expr is not None
    x2 = self.false_expr.PrettyTree()
    L.append(field('false_expr', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('arith_expr.TernaryOp')
    L = out_node.fields
    assert self.cond is not None
    x0 = self.cond.AbbreviatedTree()
    L.append(field('cond', x0))

    assert self.true_expr is not None
    x1 = self.true_expr.AbbreviatedTree()
    L.append(field('true_expr', x1))

    assert self.false_expr is not None
    x2 = self.false_expr.AbbreviatedTree()
    L.append(field('false_expr', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class arith_expr(object):
  UnaryAssign = arith_expr__UnaryAssign
  BinaryAssign = arith_expr__BinaryAssign
  Unary = arith_expr__Unary
  Binary = arith_expr__Binary
  TernaryOp = arith_expr__TernaryOp

class bool_expr_e(object):
  WordTest = 1
  Binary = 2
  Unary = 3
  LogicalNot = 4
  LogicalAnd = 5
  LogicalOr = 6

_bool_expr_str = {
  1: 'bool_expr.WordTest',
  2: 'bool_expr.Binary',
  3: 'bool_expr.Unary',
  4: 'bool_expr.LogicalNot',
  5: 'bool_expr.LogicalAnd',
  6: 'bool_expr.LogicalOr',
}

def bool_expr_str(tag):
  # type: (int) -> str
  return _bool_expr_str[tag]

class bool_expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class bool_expr__WordTest(bool_expr_t):
  _type_tag = 1
  __slots__ = ('w',)

  def __init__(self, w):
    # type: (Optional[word_t]) -> None
    self.w = w

  @staticmethod
  def Create():
    # type: () -> bool_expr__WordTest
    return bool_expr__WordTest(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.WordTest')
    L = out_node.fields

    assert self.w is not None
    x0 = self.w.PrettyTree()
    L.append(field('w', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.WordTest')
    L = out_node.fields
    assert self.w is not None
    x0 = self.w.AbbreviatedTree()
    L.append(field('w', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr__Binary(bool_expr_t):
  _type_tag = 2
  __slots__ = ('op_id', 'left', 'right')

  def __init__(self, op_id, left, right):
    # type: (Id_t, Optional[word_t], Optional[word_t]) -> None
    self.op_id = op_id
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> bool_expr__Binary
    return bool_expr__Binary(-1, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.Binary')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.PrettyTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.Binary')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.left is not None
    x1 = self.left.AbbreviatedTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr__Unary(bool_expr_t):
  _type_tag = 3
  __slots__ = ('op_id', 'child')

  def __init__(self, op_id, child):
    # type: (Id_t, Optional[word_t]) -> None
    self.op_id = op_id
    self.child = child

  @staticmethod
  def Create():
    # type: () -> bool_expr__Unary
    return bool_expr__Unary(-1, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.Unary')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.Unary')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr__LogicalNot(bool_expr_t):
  _type_tag = 4
  __slots__ = ('child',)

  def __init__(self, child):
    # type: (Optional[bool_expr_t]) -> None
    self.child = child

  @staticmethod
  def Create():
    # type: () -> bool_expr__LogicalNot
    return bool_expr__LogicalNot(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalNot')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalNot')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr__LogicalAnd(bool_expr_t):
  _type_tag = 5
  __slots__ = ('left', 'right')

  def __init__(self, left, right):
    # type: (Optional[bool_expr_t], Optional[bool_expr_t]) -> None
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> bool_expr__LogicalAnd
    return bool_expr__LogicalAnd(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalAnd')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    assert self.right is not None
    x1 = self.right.PrettyTree()
    L.append(field('right', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalAnd')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    assert self.right is not None
    x1 = self.right.AbbreviatedTree()
    L.append(field('right', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr__LogicalOr(bool_expr_t):
  _type_tag = 6
  __slots__ = ('left', 'right')

  def __init__(self, left, right):
    # type: (Optional[bool_expr_t], Optional[bool_expr_t]) -> None
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> bool_expr__LogicalOr
    return bool_expr__LogicalOr(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalOr')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    assert self.right is not None
    x1 = self.right.PrettyTree()
    L.append(field('right', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('bool_expr.LogicalOr')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    assert self.right is not None
    x1 = self.right.AbbreviatedTree()
    L.append(field('right', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class bool_expr(object):
  WordTest = bool_expr__WordTest
  Binary = bool_expr__Binary
  Unary = bool_expr__Unary
  LogicalNot = bool_expr__LogicalNot
  LogicalAnd = bool_expr__LogicalAnd
  LogicalOr = bool_expr__LogicalOr

class redir_loc_e(object):
  Fd = 1
  VarName = 2

_redir_loc_str = {
  1: 'redir_loc.Fd',
  2: 'redir_loc.VarName',
}

def redir_loc_str(tag):
  # type: (int) -> str
  return _redir_loc_str[tag]

class redir_loc_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class redir_loc__Fd(redir_loc_t):
  _type_tag = 1
  __slots__ = ('fd',)

  def __init__(self, fd):
    # type: (int) -> None
    self.fd = fd

  @staticmethod
  def Create():
    # type: () -> redir_loc__Fd
    return redir_loc__Fd(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_loc.Fd')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.fd), color_e.OtherConst)
    L.append(field('fd', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_loc.Fd')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.fd), color_e.OtherConst)
    L.append(field('fd', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class redir_loc__VarName(redir_loc_t):
  _type_tag = 2
  __slots__ = ('name',)

  def __init__(self, name):
    # type: (str) -> None
    self.name = name

  @staticmethod
  def Create():
    # type: () -> redir_loc__VarName
    return redir_loc__VarName('')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_loc.VarName')
    L = out_node.fields

    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_loc.VarName')
    L = out_node.fields
    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class redir_loc(object):
  Fd = redir_loc__Fd
  VarName = redir_loc__VarName

class redir_param_e(object):
  Word = 75
  HereDoc = 2

_redir_param_str = {
  2: 'redir_param.HereDoc',
  75: 'redir_param.Word',
}

def redir_param_str(tag):
  # type: (int) -> str
  return _redir_param_str[tag]

class redir_param_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class redir_param__HereDoc(redir_param_t):
  _type_tag = 2
  __slots__ = ('here_begin', 'here_end_span_id', 'stdin_parts')

  def __init__(self, here_begin, here_end_span_id, stdin_parts):
    # type: (Optional[word_t], int, Optional[List[word_part_t]]) -> None
    self.here_begin = here_begin
    self.here_end_span_id = here_end_span_id
    self.stdin_parts = stdin_parts

  @staticmethod
  def Create():
    # type: () -> redir_param__HereDoc
    return redir_param__HereDoc(None, -1, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_param.HereDoc')
    L = out_node.fields

    assert self.here_begin is not None
    x0 = self.here_begin.PrettyTree()
    L.append(field('here_begin', x0))

    x1 = hnode.Leaf(str(self.here_end_span_id), color_e.OtherConst)
    L.append(field('here_end_span_id', x1))

    if self.stdin_parts is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.stdin_parts:
        x2.children.append(i2.PrettyTree())
      L.append(field('stdin_parts', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir_param.HereDoc')
    L = out_node.fields
    assert self.here_begin is not None
    x0 = self.here_begin.AbbreviatedTree()
    L.append(field('here_begin', x0))

    x1 = hnode.Leaf(str(self.here_end_span_id), color_e.OtherConst)
    L.append(field('here_end_span_id', x1))

    if self.stdin_parts is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.stdin_parts:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('stdin_parts', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class redir_param(object):
  HereDoc = redir_param__HereDoc

class assign_op_t(pybase.SimpleObj):
  pass

class assign_op_e(object):
  Equal = assign_op_t(1)
  PlusEqual = assign_op_t(2)

_assign_op_str = {
  1: 'assign_op.Equal',
  2: 'assign_op.PlusEqual',
}

def assign_op_str(val):
  # type: (assign_op_t) -> str
  return _assign_op_str[val]

class condition_e(object):
  Shell = 1
  Oil = 2

_condition_str = {
  1: 'condition.Shell',
  2: 'condition.Oil',
}

def condition_str(tag):
  # type: (int) -> str
  return _condition_str[tag]

class condition_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class condition__Shell(condition_t):
  _type_tag = 1
  __slots__ = ('commands',)

  def __init__(self, commands):
    # type: (Optional[List[command_t]]) -> None
    self.commands = commands

  @staticmethod
  def Create():
    # type: () -> condition__Shell
    return condition__Shell([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('condition.Shell')
    L = out_node.fields

    if self.commands is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.commands:
        x0.children.append(i0.PrettyTree())
      L.append(field('commands', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('condition.Shell')
    L = out_node.fields
    if self.commands is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.commands:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('commands', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class condition__Oil(condition_t):
  _type_tag = 2
  __slots__ = ('e',)

  def __init__(self, e):
    # type: (Optional[expr_t]) -> None
    self.e = e

  @staticmethod
  def Create():
    # type: () -> condition__Oil
    return condition__Oil(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('condition.Oil')
    L = out_node.fields

    assert self.e is not None
    x0 = self.e.PrettyTree()
    L.append(field('e', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('condition.Oil')
    L = out_node.fields
    assert self.e is not None
    x0 = self.e.AbbreviatedTree()
    L.append(field('e', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class condition(object):
  Shell = condition__Shell
  Oil = condition__Oil

class for_iter_e(object):
  Args = 1
  Words = 2
  Oil = 3

_for_iter_str = {
  1: 'for_iter.Args',
  2: 'for_iter.Words',
  3: 'for_iter.Oil',
}

def for_iter_str(tag):
  # type: (int) -> str
  return _for_iter_str[tag]

class for_iter_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class for_iter__Args(for_iter_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Args')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Args')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class for_iter__Words(for_iter_t):
  _type_tag = 2
  __slots__ = ('words',)

  def __init__(self, words):
    # type: (Optional[List[word_t]]) -> None
    self.words = words

  @staticmethod
  def Create():
    # type: () -> for_iter__Words
    return for_iter__Words([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Words')
    L = out_node.fields

    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.PrettyTree())
      L.append(field('words', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Words')
    L = out_node.fields
    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('words', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class for_iter__Oil(for_iter_t):
  _type_tag = 3
  __slots__ = ('e', 'blame')

  def __init__(self, e, blame):
    # type: (Optional[expr_t], Optional[Token]) -> None
    self.e = e
    self.blame = blame

  @staticmethod
  def Create():
    # type: () -> for_iter__Oil
    return for_iter__Oil(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Oil')
    L = out_node.fields

    assert self.e is not None
    x0 = self.e.PrettyTree()
    L.append(field('e', x0))

    assert self.blame is not None
    x1 = self.blame.PrettyTree()
    L.append(field('blame', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter.Oil')
    L = out_node.fields
    assert self.e is not None
    x0 = self.e.AbbreviatedTree()
    L.append(field('e', x0))

    assert self.blame is not None
    x1 = self.blame.AbbreviatedTree()
    L.append(field('blame', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class for_iter(object):
  Args = for_iter__Args
  Words = for_iter__Words
  Oil = for_iter__Oil

class command_e(object):
  NoOp = 1
  Simple = 2
  ExpandedAlias = 3
  Sentence = 4
  ShAssignment = 5
  ControlFlow = 6
  Pipeline = 7
  AndOr = 8
  DoGroup = 9
  BraceGroup = 83
  Subshell = 11
  DParen = 12
  DBracket = 13
  ForEach = 14
  ForExpr = 15
  WhileUntil = 16
  If = 17
  Case = 18
  ShFunction = 19
  TimeBlock = 20
  CommandList = 21
  BareDecl = 22
  VarDecl = 23
  PlaceMutation = 24
  Expr = 25
  Proc = 26
  Func = 27
  Data = 28
  Enum = 29
  Class = 30
  Import = 31
  For = 32
  While = 33
  Break = 34
  Continue = 35
  Return = 36

_command_str = {
  1: 'command.NoOp',
  2: 'command.Simple',
  3: 'command.ExpandedAlias',
  4: 'command.Sentence',
  5: 'command.ShAssignment',
  6: 'command.ControlFlow',
  7: 'command.Pipeline',
  8: 'command.AndOr',
  9: 'command.DoGroup',
  11: 'command.Subshell',
  12: 'command.DParen',
  13: 'command.DBracket',
  14: 'command.ForEach',
  15: 'command.ForExpr',
  16: 'command.WhileUntil',
  17: 'command.If',
  18: 'command.Case',
  19: 'command.ShFunction',
  20: 'command.TimeBlock',
  21: 'command.CommandList',
  22: 'command.BareDecl',
  23: 'command.VarDecl',
  24: 'command.PlaceMutation',
  25: 'command.Expr',
  26: 'command.Proc',
  27: 'command.Func',
  28: 'command.Data',
  29: 'command.Enum',
  30: 'command.Class',
  31: 'command.Import',
  32: 'command.For',
  33: 'command.While',
  34: 'command.Break',
  35: 'command.Continue',
  36: 'command.Return',
  83: 'command.BraceGroup',
}

def command_str(tag):
  # type: (int) -> str
  return _command_str[tag]

class command_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class command__NoOp(command_t):
  _type_tag = 1
  __slots__ = ('spids',)

  def __init__(self, spids=None):
    # type: (Optional[List[int]]) -> None
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__NoOp
    return command__NoOp([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.NoOp')
    L = out_node.fields

    if self.spids is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.spids:
        x0.children.append(hnode.Leaf(str(i0), color_e.OtherConst))
      L.append(field('spids', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.NoOp')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Simple(command_t):
  _type_tag = 2
  __slots__ = ('words', 'redirects', 'more_env', 'typed_args', 'block',
               'do_fork', 'spids')

  def __init__(self, words, redirects, more_env, typed_args, block, do_fork,
               spids=None):
    # type: (Optional[List[word_t]], Optional[List[redir]], Optional[List[env_pair]], Optional[Optional[ArgList]], Optional[Optional[BlockArg]], bool, Optional[List[int]]) -> None
    self.words = words
    self.redirects = redirects
    self.more_env = more_env
    self.typed_args = typed_args
    self.block = block
    self.do_fork = do_fork
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Simple
    return command__Simple([], [], [], None, None, False, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Simple')
    L = out_node.fields

    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.PrettyTree())
      L.append(field('words', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.more_env is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.more_env:
        x2.children.append(i2.PrettyTree())
      L.append(field('more_env', x2))

    if self.typed_args is not None:  # maybe
      x3 = self.typed_args.PrettyTree()
      L.append(field('typed_args', x3))

    if self.block is not None:  # maybe
      x4 = self.block.PrettyTree()
      L.append(field('block', x4))

    x5 = hnode.Leaf('T' if self.do_fork else 'F', color_e.OtherConst)
    L.append(field('do_fork', x5))

    if self.spids is not None:  # array
      x6 = hnode.Array([])
      for i6 in self.spids:
        x6.children.append(hnode.Leaf(str(i6), color_e.OtherConst))
      L.append(field('spids', x6))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Simple')
    L = out_node.fields
    if self.words is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.words:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('words', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    if self.more_env is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.more_env:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('more_env', x2))

    if self.typed_args is not None:  # maybe
      x3 = self.typed_args.AbbreviatedTree()
      L.append(field('typed_args', x3))

    if self.block is not None:  # maybe
      x4 = self.block.AbbreviatedTree()
      L.append(field('block', x4))

    x5 = hnode.Leaf('T' if self.do_fork else 'F', color_e.OtherConst)
    L.append(field('do_fork', x5))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _command__Simple(self)
    return p if p else self._AbbreviatedTree()

class command__ExpandedAlias(command_t):
  _type_tag = 3
  __slots__ = ('child', 'redirects', 'more_env', 'spids')

  def __init__(self, child, redirects, more_env, spids=None):
    # type: (Optional[command_t], Optional[List[redir]], Optional[List[env_pair]], Optional[List[int]]) -> None
    self.child = child
    self.redirects = redirects
    self.more_env = more_env
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ExpandedAlias
    return command__ExpandedAlias(None, [], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ExpandedAlias')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.more_env is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.more_env:
        x2.children.append(i2.PrettyTree())
      L.append(field('more_env', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ExpandedAlias')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    if self.more_env is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.more_env:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('more_env', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Sentence(command_t):
  _type_tag = 4
  __slots__ = ('child', 'terminator', 'spids')

  def __init__(self, child, terminator, spids=None):
    # type: (Optional[command_t], Optional[Token], Optional[List[int]]) -> None
    self.child = child
    self.terminator = terminator
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Sentence
    return command__Sentence(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Sentence')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    assert self.terminator is not None
    x1 = self.terminator.PrettyTree()
    L.append(field('terminator', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Sentence')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    assert self.terminator is not None
    x1 = self.terminator.AbbreviatedTree()
    L.append(field('terminator', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__ShAssignment(command_t):
  _type_tag = 5
  __slots__ = ('pairs', 'redirects', 'spids')

  def __init__(self, pairs, redirects, spids=None):
    # type: (Optional[List[assign_pair]], Optional[List[redir]], Optional[List[int]]) -> None
    self.pairs = pairs
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ShAssignment
    return command__ShAssignment([], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ShAssignment')
    L = out_node.fields

    if self.pairs is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.pairs:
        x0.children.append(i0.PrettyTree())
      L.append(field('pairs', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ShAssignment')
    L = out_node.fields
    if self.pairs is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.pairs:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('pairs', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__ControlFlow(command_t):
  _type_tag = 6
  __slots__ = ('token', 'arg_word', 'spids')

  def __init__(self, token, arg_word, spids=None):
    # type: (Optional[Token], Optional[Optional[word_t]], Optional[List[int]]) -> None
    self.token = token
    self.arg_word = arg_word
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ControlFlow
    return command__ControlFlow(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ControlFlow')
    L = out_node.fields

    assert self.token is not None
    x0 = self.token.PrettyTree()
    L.append(field('token', x0))

    if self.arg_word is not None:  # maybe
      x1 = self.arg_word.PrettyTree()
      L.append(field('arg_word', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ControlFlow')
    L = out_node.fields
    assert self.token is not None
    x0 = self.token.AbbreviatedTree()
    L.append(field('token', x0))

    if self.arg_word is not None:  # maybe
      x1 = self.arg_word.AbbreviatedTree()
      L.append(field('arg_word', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Pipeline(command_t):
  _type_tag = 7
  __slots__ = ('children', 'negated', 'stderr_indices', 'spids')

  def __init__(self, children, negated, stderr_indices, spids=None):
    # type: (Optional[List[command_t]], bool, Optional[List[int]], Optional[List[int]]) -> None
    self.children = children
    self.negated = negated
    self.stderr_indices = stderr_indices
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Pipeline
    return command__Pipeline([], False, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Pipeline')
    L = out_node.fields

    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.PrettyTree())
      L.append(field('children', x0))

    x1 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x1))

    if self.stderr_indices is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.stderr_indices:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('stderr_indices', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Pipeline')
    L = out_node.fields
    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('children', x0))

    x1 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x1))

    if self.stderr_indices is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.stderr_indices:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('stderr_indices', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__AndOr(command_t):
  _type_tag = 8
  __slots__ = ('ops', 'children', 'spids')

  def __init__(self, ops, children, spids=None):
    # type: (Optional[List[Id_t]], Optional[List[command_t]], Optional[List[int]]) -> None
    self.ops = ops
    self.children = children
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__AndOr
    return command__AndOr([], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.AndOr')
    L = out_node.fields

    if self.ops is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.ops:
        x0.children.append(hnode.Leaf(Id_str(i0), color_e.UserType))
      L.append(field('ops', x0))

    if self.children is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.children:
        x1.children.append(i1.PrettyTree())
      L.append(field('children', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.AndOr')
    L = out_node.fields
    if self.ops is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.ops:
        x0.children.append(hnode.Leaf(Id_str(i0), color_e.UserType))
      L.append(field('ops', x0))

    if self.children is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.children:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('children', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__DoGroup(command_t):
  _type_tag = 9
  __slots__ = ('children', 'spids')

  def __init__(self, children, spids=None):
    # type: (Optional[List[command_t]], Optional[List[int]]) -> None
    self.children = children
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__DoGroup
    return command__DoGroup([], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DoGroup')
    L = out_node.fields

    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.PrettyTree())
      L.append(field('children', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DoGroup')
    L = out_node.fields
    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('children', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Subshell(command_t):
  _type_tag = 11
  __slots__ = ('child', 'redirects', 'spids')

  def __init__(self, child, redirects, spids=None):
    # type: (Optional[command_t], Optional[List[redir]], Optional[List[int]]) -> None
    self.child = child
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Subshell
    return command__Subshell(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Subshell')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Subshell')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__DParen(command_t):
  _type_tag = 12
  __slots__ = ('child', 'redirects', 'spids')

  def __init__(self, child, redirects, spids=None):
    # type: (Optional[arith_expr_t], Optional[List[redir]], Optional[List[int]]) -> None
    self.child = child
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__DParen
    return command__DParen(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DParen')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DParen')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__DBracket(command_t):
  _type_tag = 13
  __slots__ = ('expr', 'redirects', 'spids')

  def __init__(self, expr, redirects, spids=None):
    # type: (Optional[bool_expr_t], Optional[List[redir]], Optional[List[int]]) -> None
    self.expr = expr
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__DBracket
    return command__DBracket(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DBracket')
    L = out_node.fields

    assert self.expr is not None
    x0 = self.expr.PrettyTree()
    L.append(field('expr', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.PrettyTree())
      L.append(field('redirects', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.DBracket')
    L = out_node.fields
    assert self.expr is not None
    x0 = self.expr.AbbreviatedTree()
    L.append(field('expr', x0))

    if self.redirects is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.redirects:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('redirects', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__ForEach(command_t):
  _type_tag = 14
  __slots__ = ('iter_names', 'iterable', 'body', 'redirects', 'spids')

  def __init__(self, iter_names, iterable, body, redirects, spids=None):
    # type: (Optional[List[str]], Optional[for_iter_t], Optional[command_t], Optional[List[redir]], Optional[List[int]]) -> None
    self.iter_names = iter_names
    self.iterable = iterable
    self.body = body
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ForEach
    return command__ForEach([], None, None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ForEach')
    L = out_node.fields

    if self.iter_names is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.iter_names:
        x0.children.append(NewLeaf(i0, color_e.StringConst))
      L.append(field('iter_names', x0))

    assert self.iterable is not None
    x1 = self.iterable.PrettyTree()
    L.append(field('iterable', x1))

    assert self.body is not None
    x2 = self.body.PrettyTree()
    L.append(field('body', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.PrettyTree())
      L.append(field('redirects', x3))

    if self.spids is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(field('spids', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ForEach')
    L = out_node.fields
    if self.iter_names is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.iter_names:
        x0.children.append(NewLeaf(i0, color_e.StringConst))
      L.append(field('iter_names', x0))

    assert self.iterable is not None
    x1 = self.iterable.AbbreviatedTree()
    L.append(field('iterable', x1))

    assert self.body is not None
    x2 = self.body.AbbreviatedTree()
    L.append(field('body', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.AbbreviatedTree())
      L.append(field('redirects', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__ForExpr(command_t):
  _type_tag = 15
  __slots__ = ('init', 'cond', 'update', 'body', 'redirects', 'spids')

  def __init__(self, init, cond, update, body, redirects, spids=None):
    # type: (Optional[Optional[arith_expr_t]], Optional[Optional[arith_expr_t]], Optional[Optional[arith_expr_t]], Optional[Optional[command_t]], Optional[List[redir]], Optional[List[int]]) -> None
    self.init = init
    self.cond = cond
    self.update = update
    self.body = body
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ForExpr
    return command__ForExpr(None, None, None, None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ForExpr')
    L = out_node.fields

    if self.init is not None:  # maybe
      x0 = self.init.PrettyTree()
      L.append(field('init', x0))

    if self.cond is not None:  # maybe
      x1 = self.cond.PrettyTree()
      L.append(field('cond', x1))

    if self.update is not None:  # maybe
      x2 = self.update.PrettyTree()
      L.append(field('update', x2))

    if self.body is not None:  # maybe
      x3 = self.body.PrettyTree()
      L.append(field('body', x3))

    if self.redirects is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.redirects:
        x4.children.append(i4.PrettyTree())
      L.append(field('redirects', x4))

    if self.spids is not None:  # array
      x5 = hnode.Array([])
      for i5 in self.spids:
        x5.children.append(hnode.Leaf(str(i5), color_e.OtherConst))
      L.append(field('spids', x5))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ForExpr')
    L = out_node.fields
    if self.init is not None:  # maybe
      x0 = self.init.AbbreviatedTree()
      L.append(field('init', x0))

    if self.cond is not None:  # maybe
      x1 = self.cond.AbbreviatedTree()
      L.append(field('cond', x1))

    if self.update is not None:  # maybe
      x2 = self.update.AbbreviatedTree()
      L.append(field('update', x2))

    if self.body is not None:  # maybe
      x3 = self.body.AbbreviatedTree()
      L.append(field('body', x3))

    if self.redirects is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.redirects:
        x4.children.append(i4.AbbreviatedTree())
      L.append(field('redirects', x4))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__WhileUntil(command_t):
  _type_tag = 16
  __slots__ = ('keyword', 'cond', 'body', 'redirects', 'spids')

  def __init__(self, keyword, cond, body, redirects, spids=None):
    # type: (Optional[Token], Optional[condition_t], Optional[command_t], Optional[List[redir]], Optional[List[int]]) -> None
    self.keyword = keyword
    self.cond = cond
    self.body = body
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__WhileUntil
    return command__WhileUntil(None, None, None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.WhileUntil')
    L = out_node.fields

    assert self.keyword is not None
    x0 = self.keyword.PrettyTree()
    L.append(field('keyword', x0))

    assert self.cond is not None
    x1 = self.cond.PrettyTree()
    L.append(field('cond', x1))

    assert self.body is not None
    x2 = self.body.PrettyTree()
    L.append(field('body', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.PrettyTree())
      L.append(field('redirects', x3))

    if self.spids is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(field('spids', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.WhileUntil')
    L = out_node.fields
    assert self.keyword is not None
    x0 = self.keyword.AbbreviatedTree()
    L.append(field('keyword', x0))

    assert self.cond is not None
    x1 = self.cond.AbbreviatedTree()
    L.append(field('cond', x1))

    assert self.body is not None
    x2 = self.body.AbbreviatedTree()
    L.append(field('body', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.AbbreviatedTree())
      L.append(field('redirects', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__If(command_t):
  _type_tag = 17
  __slots__ = ('arms', 'else_action', 'redirects', 'spids')

  def __init__(self, arms, else_action, redirects, spids=None):
    # type: (Optional[List[if_arm]], Optional[List[command_t]], Optional[List[redir]], Optional[List[int]]) -> None
    self.arms = arms
    self.else_action = else_action
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__If
    return command__If([], [], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.If')
    L = out_node.fields

    if self.arms is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.arms:
        x0.children.append(i0.PrettyTree())
      L.append(field('arms', x0))

    if self.else_action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.else_action:
        x1.children.append(i1.PrettyTree())
      L.append(field('else_action', x1))

    if self.redirects is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.redirects:
        x2.children.append(i2.PrettyTree())
      L.append(field('redirects', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.If')
    L = out_node.fields
    if self.arms is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.arms:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('arms', x0))

    if self.else_action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.else_action:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('else_action', x1))

    if self.redirects is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.redirects:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('redirects', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Case(command_t):
  _type_tag = 18
  __slots__ = ('to_match', 'arms', 'redirects', 'spids')

  def __init__(self, to_match, arms, redirects, spids=None):
    # type: (Optional[word_t], Optional[List[case_arm]], Optional[List[redir]], Optional[List[int]]) -> None
    self.to_match = to_match
    self.arms = arms
    self.redirects = redirects
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Case
    return command__Case(None, [], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Case')
    L = out_node.fields

    assert self.to_match is not None
    x0 = self.to_match.PrettyTree()
    L.append(field('to_match', x0))

    if self.arms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.arms:
        x1.children.append(i1.PrettyTree())
      L.append(field('arms', x1))

    if self.redirects is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.redirects:
        x2.children.append(i2.PrettyTree())
      L.append(field('redirects', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Case')
    L = out_node.fields
    assert self.to_match is not None
    x0 = self.to_match.AbbreviatedTree()
    L.append(field('to_match', x0))

    if self.arms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.arms:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('arms', x1))

    if self.redirects is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.redirects:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('redirects', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__ShFunction(command_t):
  _type_tag = 19
  __slots__ = ('name', 'body', 'spids')

  def __init__(self, name, body, spids=None):
    # type: (str, Optional[command_t], Optional[List[int]]) -> None
    self.name = name
    self.body = body
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__ShFunction
    return command__ShFunction('', None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ShFunction')
    L = out_node.fields

    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    assert self.body is not None
    x1 = self.body.PrettyTree()
    L.append(field('body', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.ShFunction')
    L = out_node.fields
    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    assert self.body is not None
    x1 = self.body.AbbreviatedTree()
    L.append(field('body', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__TimeBlock(command_t):
  _type_tag = 20
  __slots__ = ('pipeline', 'spids')

  def __init__(self, pipeline, spids=None):
    # type: (Optional[command_t], Optional[List[int]]) -> None
    self.pipeline = pipeline
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__TimeBlock
    return command__TimeBlock(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.TimeBlock')
    L = out_node.fields

    assert self.pipeline is not None
    x0 = self.pipeline.PrettyTree()
    L.append(field('pipeline', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.TimeBlock')
    L = out_node.fields
    assert self.pipeline is not None
    x0 = self.pipeline.AbbreviatedTree()
    L.append(field('pipeline', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__CommandList(command_t):
  _type_tag = 21
  __slots__ = ('children', 'spids')

  def __init__(self, children, spids=None):
    # type: (Optional[List[command_t]], Optional[List[int]]) -> None
    self.children = children
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__CommandList
    return command__CommandList([], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.CommandList')
    L = out_node.fields

    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.PrettyTree())
      L.append(field('children', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.CommandList')
    L = out_node.fields
    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('children', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__BareDecl(command_t):
  _type_tag = 22
  __slots__ = ('lhs', 'rhs', 'spids')

  def __init__(self, lhs, rhs, spids=None):
    # type: (Optional[Token], Optional[expr_t], Optional[List[int]]) -> None
    self.lhs = lhs
    self.rhs = rhs
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__BareDecl
    return command__BareDecl(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.BareDecl')
    L = out_node.fields

    assert self.lhs is not None
    x0 = self.lhs.PrettyTree()
    L.append(field('lhs', x0))

    assert self.rhs is not None
    x1 = self.rhs.PrettyTree()
    L.append(field('rhs', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.BareDecl')
    L = out_node.fields
    assert self.lhs is not None
    x0 = self.lhs.AbbreviatedTree()
    L.append(field('lhs', x0))

    assert self.rhs is not None
    x1 = self.rhs.AbbreviatedTree()
    L.append(field('rhs', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__VarDecl(command_t):
  _type_tag = 23
  __slots__ = ('keyword', 'lhs', 'rhs', 'spids')

  def __init__(self, keyword, lhs, rhs, spids=None):
    # type: (Optional[Optional[Token]], Optional[List[name_type]], Optional[expr_t], Optional[List[int]]) -> None
    self.keyword = keyword
    self.lhs = lhs
    self.rhs = rhs
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__VarDecl
    return command__VarDecl(None, [], None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.VarDecl')
    L = out_node.fields

    if self.keyword is not None:  # maybe
      x0 = self.keyword.PrettyTree()
      L.append(field('keyword', x0))

    if self.lhs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lhs:
        x1.children.append(i1.PrettyTree())
      L.append(field('lhs', x1))

    assert self.rhs is not None
    x2 = self.rhs.PrettyTree()
    L.append(field('rhs', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.VarDecl')
    L = out_node.fields
    if self.keyword is not None:  # maybe
      x0 = self.keyword.AbbreviatedTree()
      L.append(field('keyword', x0))

    if self.lhs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lhs:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('lhs', x1))

    assert self.rhs is not None
    x2 = self.rhs.AbbreviatedTree()
    L.append(field('rhs', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__PlaceMutation(command_t):
  _type_tag = 24
  __slots__ = ('keyword', 'lhs', 'op', 'rhs', 'spids')

  def __init__(self, keyword, lhs, op, rhs, spids=None):
    # type: (Optional[Optional[Token]], Optional[List[place_expr_t]], Optional[Token], Optional[expr_t], Optional[List[int]]) -> None
    self.keyword = keyword
    self.lhs = lhs
    self.op = op
    self.rhs = rhs
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__PlaceMutation
    return command__PlaceMutation(None, [], None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.PlaceMutation')
    L = out_node.fields

    if self.keyword is not None:  # maybe
      x0 = self.keyword.PrettyTree()
      L.append(field('keyword', x0))

    if self.lhs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lhs:
        x1.children.append(i1.PrettyTree())
      L.append(field('lhs', x1))

    assert self.op is not None
    x2 = self.op.PrettyTree()
    L.append(field('op', x2))

    assert self.rhs is not None
    x3 = self.rhs.PrettyTree()
    L.append(field('rhs', x3))

    if self.spids is not None:  # array
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(field('spids', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.PlaceMutation')
    L = out_node.fields
    if self.keyword is not None:  # maybe
      x0 = self.keyword.AbbreviatedTree()
      L.append(field('keyword', x0))

    if self.lhs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lhs:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('lhs', x1))

    assert self.op is not None
    x2 = self.op.AbbreviatedTree()
    L.append(field('op', x2))

    assert self.rhs is not None
    x3 = self.rhs.AbbreviatedTree()
    L.append(field('rhs', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Expr(command_t):
  _type_tag = 25
  __slots__ = ('keyword', 'e', 'spids')

  def __init__(self, keyword, e, spids=None):
    # type: (Optional[Token], Optional[expr_t], Optional[List[int]]) -> None
    self.keyword = keyword
    self.e = e
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Expr
    return command__Expr(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Expr')
    L = out_node.fields

    assert self.keyword is not None
    x0 = self.keyword.PrettyTree()
    L.append(field('keyword', x0))

    assert self.e is not None
    x1 = self.e.PrettyTree()
    L.append(field('e', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Expr')
    L = out_node.fields
    assert self.keyword is not None
    x0 = self.keyword.AbbreviatedTree()
    L.append(field('keyword', x0))

    assert self.e is not None
    x1 = self.e.AbbreviatedTree()
    L.append(field('e', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Proc(command_t):
  _type_tag = 26
  __slots__ = ('name', 'sig', 'body', 'spids')

  def __init__(self, name, sig, body, spids=None):
    # type: (Optional[Token], Optional[proc_sig_t], Optional[command_t], Optional[List[int]]) -> None
    self.name = name
    self.sig = sig
    self.body = body
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Proc
    return command__Proc(None, None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Proc')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    assert self.sig is not None
    x1 = self.sig.PrettyTree()
    L.append(field('sig', x1))

    assert self.body is not None
    x2 = self.body.PrettyTree()
    L.append(field('body', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Proc')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    assert self.sig is not None
    x1 = self.sig.AbbreviatedTree()
    L.append(field('sig', x1))

    assert self.body is not None
    x2 = self.body.AbbreviatedTree()
    L.append(field('body', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Func(command_t):
  _type_tag = 27
  __slots__ = ('name', 'pos_params', 'pos_splat', 'named_params',
               'named_splat', 'return_types', 'body', 'spids')

  def __init__(self, name, pos_params, pos_splat, named_params, named_splat,
               return_types, body, spids=None):
    # type: (Optional[Token], Optional[List[param]], Optional[Optional[Token]], Optional[List[param]], Optional[Optional[Token]], Optional[List[type_expr_t]], Optional[command_t], Optional[List[int]]) -> None
    self.name = name
    self.pos_params = pos_params
    self.pos_splat = pos_splat
    self.named_params = named_params
    self.named_splat = named_splat
    self.return_types = return_types
    self.body = body
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Func
    return command__Func(None, [], None, [], None, [], None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Func')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.pos_params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.pos_params:
        x1.children.append(i1.PrettyTree())
      L.append(field('pos_params', x1))

    if self.pos_splat is not None:  # maybe
      x2 = self.pos_splat.PrettyTree()
      L.append(field('pos_splat', x2))

    if self.named_params is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.named_params:
        x3.children.append(i3.PrettyTree())
      L.append(field('named_params', x3))

    if self.named_splat is not None:  # maybe
      x4 = self.named_splat.PrettyTree()
      L.append(field('named_splat', x4))

    if self.return_types is not None:  # array
      x5 = hnode.Array([])
      for i5 in self.return_types:
        x5.children.append(i5.PrettyTree())
      L.append(field('return_types', x5))

    assert self.body is not None
    x6 = self.body.PrettyTree()
    L.append(field('body', x6))

    if self.spids is not None:  # array
      x7 = hnode.Array([])
      for i7 in self.spids:
        x7.children.append(hnode.Leaf(str(i7), color_e.OtherConst))
      L.append(field('spids', x7))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Func')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.pos_params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.pos_params:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('pos_params', x1))

    if self.pos_splat is not None:  # maybe
      x2 = self.pos_splat.AbbreviatedTree()
      L.append(field('pos_splat', x2))

    if self.named_params is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.named_params:
        x3.children.append(i3.AbbreviatedTree())
      L.append(field('named_params', x3))

    if self.named_splat is not None:  # maybe
      x4 = self.named_splat.AbbreviatedTree()
      L.append(field('named_splat', x4))

    if self.return_types is not None:  # array
      x5 = hnode.Array([])
      for i5 in self.return_types:
        x5.children.append(i5.AbbreviatedTree())
      L.append(field('return_types', x5))

    assert self.body is not None
    x6 = self.body.AbbreviatedTree()
    L.append(field('body', x6))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Data(command_t):
  _type_tag = 28
  __slots__ = ('name', 'params', 'spids')

  def __init__(self, name, params, spids=None):
    # type: (Optional[Token], Optional[List[param]], Optional[List[int]]) -> None
    self.name = name
    self.params = params
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Data
    return command__Data(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Data')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.params:
        x1.children.append(i1.PrettyTree())
      L.append(field('params', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Data')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.params:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('params', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Enum(command_t):
  _type_tag = 29
  __slots__ = ('name', 'variants', 'spids')

  def __init__(self, name, variants, spids=None):
    # type: (Optional[Token], Optional[List[variant]], Optional[List[int]]) -> None
    self.name = name
    self.variants = variants
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Enum
    return command__Enum(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Enum')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.variants is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.variants:
        x1.children.append(i1.PrettyTree())
      L.append(field('variants', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Enum')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.variants is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.variants:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('variants', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Class(command_t):
  _type_tag = 30
  __slots__ = ('name', 'extends', 'items', 'spids')

  def __init__(self, name, extends, items, spids=None):
    # type: (Optional[Token], Optional[Optional[Token]], Optional[List[class_item_t]], Optional[List[int]]) -> None
    self.name = name
    self.extends = extends
    self.items = items
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Class
    return command__Class(None, None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Class')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.extends is not None:  # maybe
      x1 = self.extends.PrettyTree()
      L.append(field('extends', x1))

    if self.items is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.items:
        x2.children.append(i2.PrettyTree())
      L.append(field('items', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Class')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.extends is not None:  # maybe
      x1 = self.extends.AbbreviatedTree()
      L.append(field('extends', x1))

    if self.items is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.items:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('items', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Import(command_t):
  _type_tag = 31
  __slots__ = ('path', 'alias', 'names', 'spids')

  def __init__(self, path, alias, names, spids=None):
    # type: (Optional[single_quoted], Optional[Optional[Token]], Optional[List[import_name]], Optional[List[int]]) -> None
    self.path = path
    self.alias = alias
    self.names = names
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Import
    return command__Import(None, None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Import')
    L = out_node.fields

    assert self.path is not None
    x0 = self.path.PrettyTree()
    L.append(field('path', x0))

    if self.alias is not None:  # maybe
      x1 = self.alias.PrettyTree()
      L.append(field('alias', x1))

    if self.names is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.names:
        x2.children.append(i2.PrettyTree())
      L.append(field('names', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Import')
    L = out_node.fields
    assert self.path is not None
    x0 = self.path.AbbreviatedTree()
    L.append(field('path', x0))

    if self.alias is not None:  # maybe
      x1 = self.alias.AbbreviatedTree()
      L.append(field('alias', x1))

    if self.names is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.names:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('names', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__For(command_t):
  _type_tag = 32
  __slots__ = ('targets', 'iterable', 'body', 'spids')

  def __init__(self, targets, iterable, body, spids=None):
    # type: (Optional[List[name_type]], Optional[expr_t], Optional[command_t], Optional[List[int]]) -> None
    self.targets = targets
    self.iterable = iterable
    self.body = body
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__For
    return command__For([], None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.For')
    L = out_node.fields

    if self.targets is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.targets:
        x0.children.append(i0.PrettyTree())
      L.append(field('targets', x0))

    assert self.iterable is not None
    x1 = self.iterable.PrettyTree()
    L.append(field('iterable', x1))

    assert self.body is not None
    x2 = self.body.PrettyTree()
    L.append(field('body', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.For')
    L = out_node.fields
    if self.targets is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.targets:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('targets', x0))

    assert self.iterable is not None
    x1 = self.iterable.AbbreviatedTree()
    L.append(field('iterable', x1))

    assert self.body is not None
    x2 = self.body.AbbreviatedTree()
    L.append(field('body', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__While(command_t):
  _type_tag = 33
  __slots__ = ('test', 'body', 'spids')

  def __init__(self, test, body, spids=None):
    # type: (Optional[expr_t], Optional[command_t], Optional[List[int]]) -> None
    self.test = test
    self.body = body
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__While
    return command__While(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.While')
    L = out_node.fields

    assert self.test is not None
    x0 = self.test.PrettyTree()
    L.append(field('test', x0))

    assert self.body is not None
    x1 = self.body.PrettyTree()
    L.append(field('body', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.While')
    L = out_node.fields
    assert self.test is not None
    x0 = self.test.AbbreviatedTree()
    L.append(field('test', x0))

    assert self.body is not None
    x1 = self.body.AbbreviatedTree()
    L.append(field('body', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Break(command_t):
  _type_tag = 34
  __slots__ = ('spids',)

  def __init__(self, spids=None):
    # type: (Optional[List[int]]) -> None
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Break
    return command__Break([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Break')
    L = out_node.fields

    if self.spids is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.spids:
        x0.children.append(hnode.Leaf(str(i0), color_e.OtherConst))
      L.append(field('spids', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Break')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Continue(command_t):
  _type_tag = 35
  __slots__ = ('spids',)

  def __init__(self, spids=None):
    # type: (Optional[List[int]]) -> None
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Continue
    return command__Continue([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Continue')
    L = out_node.fields

    if self.spids is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.spids:
        x0.children.append(hnode.Leaf(str(i0), color_e.OtherConst))
      L.append(field('spids', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Continue')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Return(command_t):
  _type_tag = 36
  __slots__ = ('value', 'spids')

  def __init__(self, value, spids=None):
    # type: (Optional[Optional[expr_t]], Optional[List[int]]) -> None
    self.value = value
    self.spids = spids if spids is not None else []

  @staticmethod
  def Create():
    # type: () -> command__Return
    return command__Return(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Return')
    L = out_node.fields

    if self.value is not None:  # maybe
      x0 = self.value.PrettyTree()
      L.append(field('value', x0))

    if self.spids is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.spids:
        x1.children.append(hnode.Leaf(str(i1), color_e.OtherConst))
      L.append(field('spids', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command.Return')
    L = out_node.fields
    if self.value is not None:  # maybe
      x0 = self.value.AbbreviatedTree()
      L.append(field('value', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command(object):
  NoOp = command__NoOp
  Simple = command__Simple
  ExpandedAlias = command__ExpandedAlias
  Sentence = command__Sentence
  ShAssignment = command__ShAssignment
  ControlFlow = command__ControlFlow
  Pipeline = command__Pipeline
  AndOr = command__AndOr
  DoGroup = command__DoGroup
  Subshell = command__Subshell
  DParen = command__DParen
  DBracket = command__DBracket
  ForEach = command__ForEach
  ForExpr = command__ForExpr
  WhileUntil = command__WhileUntil
  If = command__If
  Case = command__Case
  ShFunction = command__ShFunction
  TimeBlock = command__TimeBlock
  CommandList = command__CommandList
  BareDecl = command__BareDecl
  VarDecl = command__VarDecl
  PlaceMutation = command__PlaceMutation
  Expr = command__Expr
  Proc = command__Proc
  Func = command__Func
  Data = command__Data
  Enum = command__Enum
  Class = command__Class
  Import = command__Import
  For = command__For
  While = command__While
  Break = command__Break
  Continue = command__Continue
  Return = command__Return

class variant_type_e(object):
  Anon = 1
  Ref = 2

_variant_type_str = {
  1: 'variant_type.Anon',
  2: 'variant_type.Ref',
}

def variant_type_str(tag):
  # type: (int) -> str
  return _variant_type_str[tag]

class variant_type_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class variant_type__Anon(variant_type_t):
  _type_tag = 1
  __slots__ = ('params',)

  def __init__(self, params):
    # type: (Optional[List[param]]) -> None
    self.params = params

  @staticmethod
  def Create():
    # type: () -> variant_type__Anon
    return variant_type__Anon([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant_type.Anon')
    L = out_node.fields

    if self.params is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.params:
        x0.children.append(i0.PrettyTree())
      L.append(field('params', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant_type.Anon')
    L = out_node.fields
    if self.params is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.params:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('params', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class variant_type__Ref(variant_type_t):
  _type_tag = 2
  __slots__ = ('type_name',)

  def __init__(self, type_name):
    # type: (Optional[Token]) -> None
    self.type_name = type_name

  @staticmethod
  def Create():
    # type: () -> variant_type__Ref
    return variant_type__Ref(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant_type.Ref')
    L = out_node.fields

    assert self.type_name is not None
    x0 = self.type_name.PrettyTree()
    L.append(field('type_name', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant_type.Ref')
    L = out_node.fields
    assert self.type_name is not None
    x0 = self.type_name.AbbreviatedTree()
    L.append(field('type_name', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class variant_type(object):
  Anon = variant_type__Anon
  Ref = variant_type__Ref

class class_item_e(object):
  Data = 1
  Method = 2

_class_item_str = {
  1: 'class_item.Data',
  2: 'class_item.Method',
}

def class_item_str(tag):
  # type: (int) -> str
  return _class_item_str[tag]

class class_item_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class class_item__Data(class_item_t):
  _type_tag = 1
  __slots__ = ('keyword', 'fields')

  def __init__(self, keyword, fields):
    # type: (Optional[Token], Optional[List[name_type]]) -> None
    self.keyword = keyword
    self.fields = fields

  @staticmethod
  def Create():
    # type: () -> class_item__Data
    return class_item__Data(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item.Data')
    L = out_node.fields

    assert self.keyword is not None
    x0 = self.keyword.PrettyTree()
    L.append(field('keyword', x0))

    if self.fields is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.fields:
        x1.children.append(i1.PrettyTree())
      L.append(field('fields', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item.Data')
    L = out_node.fields
    assert self.keyword is not None
    x0 = self.keyword.AbbreviatedTree()
    L.append(field('keyword', x0))

    if self.fields is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.fields:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('fields', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class class_item__Method(class_item_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item.Method')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item.Method')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class class_item(object):
  Data = class_item__Data
  Method = class_item__Method

class proc_sig_e(object):
  Open = 1
  Closed = 2

_proc_sig_str = {
  1: 'proc_sig.Open',
  2: 'proc_sig.Closed',
}

def proc_sig_str(tag):
  # type: (int) -> str
  return _proc_sig_str[tag]

class proc_sig_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class proc_sig__Open(proc_sig_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig.Open')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig.Open')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class proc_sig__Closed(proc_sig_t):
  _type_tag = 2
  __slots__ = ('untyped', 'rest', 'typed')

  def __init__(self, untyped, rest, typed):
    # type: (Optional[List[UntypedParam]], Optional[Optional[Token]], Optional[List[TypedParam]]) -> None
    self.untyped = untyped
    self.rest = rest
    self.typed = typed

  @staticmethod
  def Create():
    # type: () -> proc_sig__Closed
    return proc_sig__Closed([], None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig.Closed')
    L = out_node.fields

    if self.untyped is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.untyped:
        x0.children.append(i0.PrettyTree())
      L.append(field('untyped', x0))

    if self.rest is not None:  # maybe
      x1 = self.rest.PrettyTree()
      L.append(field('rest', x1))

    if self.typed is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.typed:
        x2.children.append(i2.PrettyTree())
      L.append(field('typed', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig.Closed')
    L = out_node.fields
    if self.untyped is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.untyped:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('untyped', x0))

    if self.rest is not None:  # maybe
      x1 = self.rest.AbbreviatedTree()
      L.append(field('rest', x1))

    if self.typed is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.typed:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('typed', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class proc_sig(object):
  Open = proc_sig__Open
  Closed = proc_sig__Closed

class glob_part_e(object):
  Literal = 1
  Operator = 2
  CharClass = 3

_glob_part_str = {
  1: 'glob_part.Literal',
  2: 'glob_part.Operator',
  3: 'glob_part.CharClass',
}

def glob_part_str(tag):
  # type: (int) -> str
  return _glob_part_str[tag]

class glob_part_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class glob_part__Literal(glob_part_t):
  _type_tag = 1
  __slots__ = ('id', 's')

  def __init__(self, id, s):
    # type: (Id_t, str) -> None
    self.id = id
    self.s = s

  @staticmethod
  def Create():
    # type: () -> glob_part__Literal
    return glob_part__Literal(-1, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.Literal')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.Literal')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class glob_part__Operator(glob_part_t):
  _type_tag = 2
  __slots__ = ('op_id',)

  def __init__(self, op_id):
    # type: (Id_t) -> None
    self.op_id = op_id

  @staticmethod
  def Create():
    # type: () -> glob_part__Operator
    return glob_part__Operator(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.Operator')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.Operator')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
    L.append(field('op_id', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class glob_part__CharClass(glob_part_t):
  _type_tag = 3
  __slots__ = ('negated', 'strs')

  def __init__(self, negated, strs):
    # type: (bool, Optional[List[str]]) -> None
    self.negated = negated
    self.strs = strs

  @staticmethod
  def Create():
    # type: () -> glob_part__CharClass
    return glob_part__CharClass(False, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.CharClass')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.strs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.strs:
        x1.children.append(NewLeaf(i1, color_e.StringConst))
      L.append(field('strs', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('glob_part.CharClass')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.strs is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.strs:
        x1.children.append(NewLeaf(i1, color_e.StringConst))
      L.append(field('strs', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class glob_part(object):
  Literal = glob_part__Literal
  Operator = glob_part__Operator
  CharClass = glob_part__CharClass

class printf_part_e(object):
  Literal = 1
  Percent = 2

_printf_part_str = {
  1: 'printf_part.Literal',
  2: 'printf_part.Percent',
}

def printf_part_str(tag):
  # type: (int) -> str
  return _printf_part_str[tag]

class printf_part_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class printf_part__Literal(printf_part_t):
  _type_tag = 1
  __slots__ = ('token',)

  def __init__(self, token):
    # type: (Optional[Token]) -> None
    self.token = token

  @staticmethod
  def Create():
    # type: () -> printf_part__Literal
    return printf_part__Literal(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('printf_part.Literal')
    L = out_node.fields

    assert self.token is not None
    x0 = self.token.PrettyTree()
    L.append(field('token', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('printf_part.Literal')
    L = out_node.fields
    assert self.token is not None
    x0 = self.token.AbbreviatedTree()
    L.append(field('token', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class printf_part__Percent(printf_part_t):
  _type_tag = 2
  __slots__ = ('flags', 'width', 'precision', 'type')

  def __init__(self, flags, width, precision, type):
    # type: (Optional[List[Token]], Optional[Optional[Token]], Optional[Optional[Token]], Optional[Token]) -> None
    self.flags = flags
    self.width = width
    self.precision = precision
    self.type = type

  @staticmethod
  def Create():
    # type: () -> printf_part__Percent
    return printf_part__Percent([], None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('printf_part.Percent')
    L = out_node.fields

    if self.flags is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.flags:
        x0.children.append(i0.PrettyTree())
      L.append(field('flags', x0))

    if self.width is not None:  # maybe
      x1 = self.width.PrettyTree()
      L.append(field('width', x1))

    if self.precision is not None:  # maybe
      x2 = self.precision.PrettyTree()
      L.append(field('precision', x2))

    assert self.type is not None
    x3 = self.type.PrettyTree()
    L.append(field('type', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('printf_part.Percent')
    L = out_node.fields
    if self.flags is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.flags:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('flags', x0))

    if self.width is not None:  # maybe
      x1 = self.width.AbbreviatedTree()
      L.append(field('width', x1))

    if self.precision is not None:  # maybe
      x2 = self.precision.AbbreviatedTree()
      L.append(field('precision', x2))

    assert self.type is not None
    x3 = self.type.AbbreviatedTree()
    L.append(field('type', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class printf_part(object):
  Literal = printf_part__Literal
  Percent = printf_part__Percent

class expr_context_t(pybase.SimpleObj):
  pass

class expr_context_e(object):
  Load = expr_context_t(1)
  Store = expr_context_t(2)
  Del = expr_context_t(3)
  AugLoad = expr_context_t(4)
  AugStore = expr_context_t(5)
  Param = expr_context_t(6)

_expr_context_str = {
  1: 'expr_context.Load',
  2: 'expr_context.Store',
  3: 'expr_context.Del',
  4: 'expr_context.AugLoad',
  5: 'expr_context.AugStore',
  6: 'expr_context.Param',
}

def expr_context_str(val):
  # type: (expr_context_t) -> str
  return _expr_context_str[val]

class type_expr_e(object):
  Simple = 1
  Compound = 2

_type_expr_str = {
  1: 'type_expr.Simple',
  2: 'type_expr.Compound',
}

def type_expr_str(tag):
  # type: (int) -> str
  return _type_expr_str[tag]

class type_expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class type_expr__Simple(type_expr_t):
  _type_tag = 1
  __slots__ = ('name',)

  def __init__(self, name):
    # type: (Optional[Token]) -> None
    self.name = name

  @staticmethod
  def Create():
    # type: () -> type_expr__Simple
    return type_expr__Simple(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('type_expr.Simple')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('type_expr.Simple')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class type_expr__Compound(type_expr_t):
  _type_tag = 2
  __slots__ = ('name', 'params')

  def __init__(self, name, params):
    # type: (Optional[Token], Optional[List[type_expr_t]]) -> None
    self.name = name
    self.params = params

  @staticmethod
  def Create():
    # type: () -> type_expr__Compound
    return type_expr__Compound(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('type_expr.Compound')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.params:
        x1.children.append(i1.PrettyTree())
      L.append(field('params', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('type_expr.Compound')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.params is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.params:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('params', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class type_expr(object):
  Simple = type_expr__Simple
  Compound = type_expr__Compound

class place_expr_e(object):
  Var = 1
  Subscript = 93
  Attribute = 94

_place_expr_str = {
  1: 'place_expr.Var',
  93: 'place_expr.Subscript',
  94: 'place_expr.Attribute',
}

def place_expr_str(tag):
  # type: (int) -> str
  return _place_expr_str[tag]

class place_expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class place_expr__Var(place_expr_t):
  _type_tag = 1
  __slots__ = ('name',)

  def __init__(self, name):
    # type: (Optional[Token]) -> None
    self.name = name

  @staticmethod
  def Create():
    # type: () -> place_expr__Var
    return place_expr__Var(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('place_expr.Var')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('place_expr.Var')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class place_expr(object):
  Var = place_expr__Var

class expr_e(object):
  Var = 1
  Const = 2
  ShArrayLiteral = 72
  RegexLiteral = 4
  SimpleVarSub = 70
  BracedVarSub = 67
  CommandSub = 71
  SingleQuoted = 69
  DoubleQuoted = 68
  BlockArg = 84
  Lambda = 11
  Unary = 12
  Binary = 13
  Compare = 14
  FuncCall = 15
  IfExp = 16
  Tuple = 17
  List = 18
  Dict = 19
  Implicit = 20
  ListComp = 21
  DictComp = 22
  GeneratorExp = 23
  Range = 24
  Slice = 25
  Subscript = 93
  Attribute = 94
  Spread = 28

_expr_str = {
  1: 'expr.Var',
  2: 'expr.Const',
  4: 'expr.RegexLiteral',
  11: 'expr.Lambda',
  12: 'expr.Unary',
  13: 'expr.Binary',
  14: 'expr.Compare',
  15: 'expr.FuncCall',
  16: 'expr.IfExp',
  17: 'expr.Tuple',
  18: 'expr.List',
  19: 'expr.Dict',
  20: 'expr.Implicit',
  21: 'expr.ListComp',
  22: 'expr.DictComp',
  23: 'expr.GeneratorExp',
  24: 'expr.Range',
  25: 'expr.Slice',
  28: 'expr.Spread',
  67: 'expr.BracedVarSub',
  68: 'expr.DoubleQuoted',
  69: 'expr.SingleQuoted',
  70: 'expr.SimpleVarSub',
  71: 'expr.CommandSub',
  72: 'expr.ShArrayLiteral',
  84: 'expr.BlockArg',
  93: 'expr.Subscript',
  94: 'expr.Attribute',
}

def expr_str(tag):
  # type: (int) -> str
  return _expr_str[tag]

class expr_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class expr__Var(expr_t):
  _type_tag = 1
  __slots__ = ('name',)

  def __init__(self, name):
    # type: (Optional[Token]) -> None
    self.name = name

  @staticmethod
  def Create():
    # type: () -> expr__Var
    return expr__Var(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Var')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Var')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _expr__Var(self)
    return p if p else self._AbbreviatedTree()

class expr__Const(expr_t):
  _type_tag = 2
  __slots__ = ('c',)

  def __init__(self, c):
    # type: (Optional[Token]) -> None
    self.c = c

  @staticmethod
  def Create():
    # type: () -> expr__Const
    return expr__Const(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Const')
    L = out_node.fields

    assert self.c is not None
    x0 = self.c.PrettyTree()
    L.append(field('c', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Const')
    L = out_node.fields
    assert self.c is not None
    x0 = self.c.AbbreviatedTree()
    L.append(field('c', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _expr__Const(self)
    return p if p else self._AbbreviatedTree()

class expr__RegexLiteral(expr_t):
  _type_tag = 4
  __slots__ = ('left', 'regex', 'flags', 'trans_pref')

  def __init__(self, left, regex, flags, trans_pref):
    # type: (Optional[Token], Optional[re_t], Optional[List[Token]], Optional[Optional[Token]]) -> None
    self.left = left
    self.regex = regex
    self.flags = flags
    self.trans_pref = trans_pref

  @staticmethod
  def Create():
    # type: () -> expr__RegexLiteral
    return expr__RegexLiteral(None, None, [], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.RegexLiteral')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    assert self.regex is not None
    x1 = self.regex.PrettyTree()
    L.append(field('regex', x1))

    if self.flags is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.flags:
        x2.children.append(i2.PrettyTree())
      L.append(field('flags', x2))

    if self.trans_pref is not None:  # maybe
      x3 = self.trans_pref.PrettyTree()
      L.append(field('trans_pref', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.RegexLiteral')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    assert self.regex is not None
    x1 = self.regex.AbbreviatedTree()
    L.append(field('regex', x1))

    if self.flags is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.flags:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('flags', x2))

    if self.trans_pref is not None:  # maybe
      x3 = self.trans_pref.AbbreviatedTree()
      L.append(field('trans_pref', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Lambda(expr_t):
  _type_tag = 11
  __slots__ = ('params', 'body')

  def __init__(self, params, body):
    # type: (Optional[List[name_type]], Optional[expr_t]) -> None
    self.params = params
    self.body = body

  @staticmethod
  def Create():
    # type: () -> expr__Lambda
    return expr__Lambda([], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Lambda')
    L = out_node.fields

    if self.params is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.params:
        x0.children.append(i0.PrettyTree())
      L.append(field('params', x0))

    assert self.body is not None
    x1 = self.body.PrettyTree()
    L.append(field('body', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Lambda')
    L = out_node.fields
    if self.params is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.params:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('params', x0))

    assert self.body is not None
    x1 = self.body.AbbreviatedTree()
    L.append(field('body', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Unary(expr_t):
  _type_tag = 12
  __slots__ = ('op', 'child')

  def __init__(self, op, child):
    # type: (Optional[Token], Optional[expr_t]) -> None
    self.op = op
    self.child = child

  @staticmethod
  def Create():
    # type: () -> expr__Unary
    return expr__Unary(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Unary')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Unary')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Binary(expr_t):
  _type_tag = 13
  __slots__ = ('op', 'left', 'right')

  def __init__(self, op, left, right):
    # type: (Optional[Token], Optional[expr_t], Optional[expr_t]) -> None
    self.op = op
    self.left = left
    self.right = right

  @staticmethod
  def Create():
    # type: () -> expr__Binary
    return expr__Binary(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Binary')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    assert self.left is not None
    x1 = self.left.PrettyTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Binary')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    assert self.left is not None
    x1 = self.left.AbbreviatedTree()
    L.append(field('left', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Compare(expr_t):
  _type_tag = 14
  __slots__ = ('left', 'ops', 'comparators')

  def __init__(self, left, ops, comparators):
    # type: (Optional[expr_t], Optional[List[Token]], Optional[List[expr_t]]) -> None
    self.left = left
    self.ops = ops
    self.comparators = comparators

  @staticmethod
  def Create():
    # type: () -> expr__Compare
    return expr__Compare(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Compare')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.ops is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.ops:
        x1.children.append(i1.PrettyTree())
      L.append(field('ops', x1))

    if self.comparators is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.comparators:
        x2.children.append(i2.PrettyTree())
      L.append(field('comparators', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Compare')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.ops is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.ops:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('ops', x1))

    if self.comparators is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.comparators:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('comparators', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__FuncCall(expr_t):
  _type_tag = 15
  __slots__ = ('func', 'args')

  def __init__(self, func, args):
    # type: (Optional[expr_t], Optional[ArgList]) -> None
    self.func = func
    self.args = args

  @staticmethod
  def Create():
    # type: () -> expr__FuncCall
    return expr__FuncCall(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.FuncCall')
    L = out_node.fields

    assert self.func is not None
    x0 = self.func.PrettyTree()
    L.append(field('func', x0))

    assert self.args is not None
    x1 = self.args.PrettyTree()
    L.append(field('args', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.FuncCall')
    L = out_node.fields
    assert self.func is not None
    x0 = self.func.AbbreviatedTree()
    L.append(field('func', x0))

    assert self.args is not None
    x1 = self.args.AbbreviatedTree()
    L.append(field('args', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__IfExp(expr_t):
  _type_tag = 16
  __slots__ = ('test', 'body', 'orelse')

  def __init__(self, test, body, orelse):
    # type: (Optional[expr_t], Optional[expr_t], Optional[expr_t]) -> None
    self.test = test
    self.body = body
    self.orelse = orelse

  @staticmethod
  def Create():
    # type: () -> expr__IfExp
    return expr__IfExp(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.IfExp')
    L = out_node.fields

    assert self.test is not None
    x0 = self.test.PrettyTree()
    L.append(field('test', x0))

    assert self.body is not None
    x1 = self.body.PrettyTree()
    L.append(field('body', x1))

    assert self.orelse is not None
    x2 = self.orelse.PrettyTree()
    L.append(field('orelse', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.IfExp')
    L = out_node.fields
    assert self.test is not None
    x0 = self.test.AbbreviatedTree()
    L.append(field('test', x0))

    assert self.body is not None
    x1 = self.body.AbbreviatedTree()
    L.append(field('body', x1))

    assert self.orelse is not None
    x2 = self.orelse.AbbreviatedTree()
    L.append(field('orelse', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Tuple(expr_t):
  _type_tag = 17
  __slots__ = ('elts', 'ctx')

  def __init__(self, elts, ctx):
    # type: (Optional[List[expr_t]], expr_context_t) -> None
    self.elts = elts
    self.ctx = ctx

  @staticmethod
  def Create():
    # type: () -> expr__Tuple
    return expr__Tuple([], expr_context_e.Load)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Tuple')
    L = out_node.fields

    if self.elts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.elts:
        x0.children.append(i0.PrettyTree())
      L.append(field('elts', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Tuple')
    L = out_node.fields
    if self.elts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.elts:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('elts', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__List(expr_t):
  _type_tag = 18
  __slots__ = ('elts', 'ctx')

  def __init__(self, elts, ctx):
    # type: (Optional[List[expr_t]], expr_context_t) -> None
    self.elts = elts
    self.ctx = ctx

  @staticmethod
  def Create():
    # type: () -> expr__List
    return expr__List([], expr_context_e.Load)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.List')
    L = out_node.fields

    if self.elts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.elts:
        x0.children.append(i0.PrettyTree())
      L.append(field('elts', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.List')
    L = out_node.fields
    if self.elts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.elts:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('elts', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Dict(expr_t):
  _type_tag = 19
  __slots__ = ('keys', 'values')

  def __init__(self, keys, values):
    # type: (Optional[List[expr_t]], Optional[List[expr_t]]) -> None
    self.keys = keys
    self.values = values

  @staticmethod
  def Create():
    # type: () -> expr__Dict
    return expr__Dict([], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Dict')
    L = out_node.fields

    if self.keys is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.keys:
        x0.children.append(i0.PrettyTree())
      L.append(field('keys', x0))

    if self.values is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.values:
        x1.children.append(i1.PrettyTree())
      L.append(field('values', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Dict')
    L = out_node.fields
    if self.keys is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.keys:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('keys', x0))

    if self.values is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.values:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('values', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Implicit(expr_t):
  _type_tag = 20
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Implicit')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Implicit')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__ListComp(expr_t):
  _type_tag = 21
  __slots__ = ('elt', 'generators')

  def __init__(self, elt, generators):
    # type: (Optional[expr_t], Optional[List[comprehension]]) -> None
    self.elt = elt
    self.generators = generators

  @staticmethod
  def Create():
    # type: () -> expr__ListComp
    return expr__ListComp(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.ListComp')
    L = out_node.fields

    assert self.elt is not None
    x0 = self.elt.PrettyTree()
    L.append(field('elt', x0))

    if self.generators is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.generators:
        x1.children.append(i1.PrettyTree())
      L.append(field('generators', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.ListComp')
    L = out_node.fields
    assert self.elt is not None
    x0 = self.elt.AbbreviatedTree()
    L.append(field('elt', x0))

    if self.generators is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.generators:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('generators', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__DictComp(expr_t):
  _type_tag = 22
  __slots__ = ('key', 'value', 'generators')

  def __init__(self, key, value, generators):
    # type: (Optional[expr_t], Optional[expr_t], Optional[List[comprehension]]) -> None
    self.key = key
    self.value = value
    self.generators = generators

  @staticmethod
  def Create():
    # type: () -> expr__DictComp
    return expr__DictComp(None, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.DictComp')
    L = out_node.fields

    assert self.key is not None
    x0 = self.key.PrettyTree()
    L.append(field('key', x0))

    assert self.value is not None
    x1 = self.value.PrettyTree()
    L.append(field('value', x1))

    if self.generators is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.generators:
        x2.children.append(i2.PrettyTree())
      L.append(field('generators', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.DictComp')
    L = out_node.fields
    assert self.key is not None
    x0 = self.key.AbbreviatedTree()
    L.append(field('key', x0))

    assert self.value is not None
    x1 = self.value.AbbreviatedTree()
    L.append(field('value', x1))

    if self.generators is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.generators:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('generators', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__GeneratorExp(expr_t):
  _type_tag = 23
  __slots__ = ('elt', 'generators')

  def __init__(self, elt, generators):
    # type: (Optional[expr_t], Optional[List[comprehension]]) -> None
    self.elt = elt
    self.generators = generators

  @staticmethod
  def Create():
    # type: () -> expr__GeneratorExp
    return expr__GeneratorExp(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.GeneratorExp')
    L = out_node.fields

    assert self.elt is not None
    x0 = self.elt.PrettyTree()
    L.append(field('elt', x0))

    if self.generators is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.generators:
        x1.children.append(i1.PrettyTree())
      L.append(field('generators', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.GeneratorExp')
    L = out_node.fields
    assert self.elt is not None
    x0 = self.elt.AbbreviatedTree()
    L.append(field('elt', x0))

    if self.generators is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.generators:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('generators', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Range(expr_t):
  _type_tag = 24
  __slots__ = ('lower', 'upper')

  def __init__(self, lower, upper):
    # type: (Optional[expr_t], Optional[expr_t]) -> None
    self.lower = lower
    self.upper = upper

  @staticmethod
  def Create():
    # type: () -> expr__Range
    return expr__Range(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Range')
    L = out_node.fields

    assert self.lower is not None
    x0 = self.lower.PrettyTree()
    L.append(field('lower', x0))

    assert self.upper is not None
    x1 = self.upper.PrettyTree()
    L.append(field('upper', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Range')
    L = out_node.fields
    assert self.lower is not None
    x0 = self.lower.AbbreviatedTree()
    L.append(field('lower', x0))

    assert self.upper is not None
    x1 = self.upper.AbbreviatedTree()
    L.append(field('upper', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Slice(expr_t):
  _type_tag = 25
  __slots__ = ('lower', 'upper')

  def __init__(self, lower, upper):
    # type: (Optional[Optional[expr_t]], Optional[Optional[expr_t]]) -> None
    self.lower = lower
    self.upper = upper

  @staticmethod
  def Create():
    # type: () -> expr__Slice
    return expr__Slice(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Slice')
    L = out_node.fields

    if self.lower is not None:  # maybe
      x0 = self.lower.PrettyTree()
      L.append(field('lower', x0))

    if self.upper is not None:  # maybe
      x1 = self.upper.PrettyTree()
      L.append(field('upper', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Slice')
    L = out_node.fields
    if self.lower is not None:  # maybe
      x0 = self.lower.AbbreviatedTree()
      L.append(field('lower', x0))

    if self.upper is not None:  # maybe
      x1 = self.upper.AbbreviatedTree()
      L.append(field('upper', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr__Spread(expr_t):
  _type_tag = 28
  __slots__ = ('child', 'ctx')

  def __init__(self, child, ctx):
    # type: (Optional[expr_t], expr_context_t) -> None
    self.child = child
    self.ctx = ctx

  @staticmethod
  def Create():
    # type: () -> expr__Spread
    return expr__Spread(None, expr_context_e.Load)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Spread')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr.Spread')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr(object):
  Var = expr__Var
  Const = expr__Const
  RegexLiteral = expr__RegexLiteral
  Lambda = expr__Lambda
  Unary = expr__Unary
  Binary = expr__Binary
  Compare = expr__Compare
  FuncCall = expr__FuncCall
  IfExp = expr__IfExp
  Tuple = expr__Tuple
  List = expr__List
  Dict = expr__Dict
  Implicit = expr__Implicit
  ListComp = expr__ListComp
  DictComp = expr__DictComp
  GeneratorExp = expr__GeneratorExp
  Range = expr__Range
  Slice = expr__Slice
  Spread = expr__Spread

class class_literal_term_e(object):
  PosixClass = 95
  PerlClass = 96
  Range = 3
  CharLiteral = 4
  SimpleVarSub = 70
  BracedVarSub = 67
  SingleQuoted = 69
  DoubleQuoted = 68

_class_literal_term_str = {
  3: 'class_literal_term.Range',
  4: 'class_literal_term.CharLiteral',
  67: 'class_literal_term.BracedVarSub',
  68: 'class_literal_term.DoubleQuoted',
  69: 'class_literal_term.SingleQuoted',
  70: 'class_literal_term.SimpleVarSub',
  95: 'class_literal_term.PosixClass',
  96: 'class_literal_term.PerlClass',
}

def class_literal_term_str(tag):
  # type: (int) -> str
  return _class_literal_term_str[tag]

class class_literal_term_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class class_literal_term__Range(class_literal_term_t):
  _type_tag = 3
  __slots__ = ('start', 'end')

  def __init__(self, start, end):
    # type: (Optional[Token], Optional[Token]) -> None
    self.start = start
    self.end = end

  @staticmethod
  def Create():
    # type: () -> class_literal_term__Range
    return class_literal_term__Range(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_literal_term.Range')
    L = out_node.fields

    assert self.start is not None
    x0 = self.start.PrettyTree()
    L.append(field('start', x0))

    assert self.end is not None
    x1 = self.end.PrettyTree()
    L.append(field('end', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_literal_term.Range')
    L = out_node.fields
    assert self.start is not None
    x0 = self.start.AbbreviatedTree()
    L.append(field('start', x0))

    assert self.end is not None
    x1 = self.end.AbbreviatedTree()
    L.append(field('end', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class class_literal_term__CharLiteral(class_literal_term_t):
  _type_tag = 4
  __slots__ = ('tok',)

  def __init__(self, tok):
    # type: (Optional[Token]) -> None
    self.tok = tok

  @staticmethod
  def Create():
    # type: () -> class_literal_term__CharLiteral
    return class_literal_term__CharLiteral(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_literal_term.CharLiteral')
    L = out_node.fields

    assert self.tok is not None
    x0 = self.tok.PrettyTree()
    L.append(field('tok', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_literal_term.CharLiteral')
    L = out_node.fields
    assert self.tok is not None
    x0 = self.tok.AbbreviatedTree()
    L.append(field('tok', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class class_literal_term(object):
  Range = class_literal_term__Range
  CharLiteral = class_literal_term__CharLiteral

class char_class_term_e(object):
  PosixClass = 95
  PerlClass = 96
  Range = 3
  CharCode = 97

_char_class_term_str = {
  3: 'char_class_term.Range',
  95: 'char_class_term.PosixClass',
  96: 'char_class_term.PerlClass',
  97: 'char_class_term.CharCode',
}

def char_class_term_str(tag):
  # type: (int) -> str
  return _char_class_term_str[tag]

class char_class_term_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class char_class_term__Range(char_class_term_t):
  _type_tag = 3
  __slots__ = ('start', 'end')

  def __init__(self, start, end):
    # type: (Optional[CharCode], Optional[CharCode]) -> None
    self.start = start
    self.end = end

  @staticmethod
  def Create():
    # type: () -> char_class_term__Range
    return char_class_term__Range(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('char_class_term.Range')
    L = out_node.fields

    assert self.start is not None
    x0 = self.start.PrettyTree()
    L.append(field('start', x0))

    assert self.end is not None
    x1 = self.end.PrettyTree()
    L.append(field('end', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('char_class_term.Range')
    L = out_node.fields
    assert self.start is not None
    x0 = self.start.AbbreviatedTree()
    L.append(field('start', x0))

    assert self.end is not None
    x1 = self.end.AbbreviatedTree()
    L.append(field('end', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class char_class_term(object):
  Range = char_class_term__Range

class re_repeat_e(object):
  Op = 1
  Num = 2
  Range = 3

_re_repeat_str = {
  1: 're_repeat.Op',
  2: 're_repeat.Num',
  3: 're_repeat.Range',
}

def re_repeat_str(tag):
  # type: (int) -> str
  return _re_repeat_str[tag]

class re_repeat_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class re_repeat__Op(re_repeat_t):
  _type_tag = 1
  __slots__ = ('op',)

  def __init__(self, op):
    # type: (Optional[Token]) -> None
    self.op = op

  @staticmethod
  def Create():
    # type: () -> re_repeat__Op
    return re_repeat__Op(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Op')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Op')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re_repeat__Num(re_repeat_t):
  _type_tag = 2
  __slots__ = ('times',)

  def __init__(self, times):
    # type: (Optional[Token]) -> None
    self.times = times

  @staticmethod
  def Create():
    # type: () -> re_repeat__Num
    return re_repeat__Num(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Num')
    L = out_node.fields

    assert self.times is not None
    x0 = self.times.PrettyTree()
    L.append(field('times', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Num')
    L = out_node.fields
    assert self.times is not None
    x0 = self.times.AbbreviatedTree()
    L.append(field('times', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re_repeat__Range(re_repeat_t):
  _type_tag = 3
  __slots__ = ('lower', 'upper')

  def __init__(self, lower, upper):
    # type: (Optional[Optional[Token]], Optional[Optional[Token]]) -> None
    self.lower = lower
    self.upper = upper

  @staticmethod
  def Create():
    # type: () -> re_repeat__Range
    return re_repeat__Range(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Range')
    L = out_node.fields

    if self.lower is not None:  # maybe
      x0 = self.lower.PrettyTree()
      L.append(field('lower', x0))

    if self.upper is not None:  # maybe
      x1 = self.upper.PrettyTree()
      L.append(field('upper', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re_repeat.Range')
    L = out_node.fields
    if self.lower is not None:  # maybe
      x0 = self.lower.AbbreviatedTree()
      L.append(field('lower', x0))

    if self.upper is not None:  # maybe
      x1 = self.upper.AbbreviatedTree()
      L.append(field('upper', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re_repeat(object):
  Op = re_repeat__Op
  Num = re_repeat__Num
  Range = re_repeat__Range

class re_e(object):
  Token = 66
  PosixClass = 95
  PerlClass = 96
  CharClassLiteral = 4
  CharClass = 5
  Splice = 6
  SimpleVarSub = 70
  BracedVarSub = 67
  SingleQuoted = 69
  DoubleQuoted = 68
  Repeat = 11
  Seq = 12
  Alt = 13
  Group = 14
  Capture = 15
  Backtracking = 16
  Primitive = 17
  LiteralChars = 18

_re_str = {
  4: 're.CharClassLiteral',
  5: 're.CharClass',
  6: 're.Splice',
  11: 're.Repeat',
  12: 're.Seq',
  13: 're.Alt',
  14: 're.Group',
  15: 're.Capture',
  16: 're.Backtracking',
  17: 're.Primitive',
  18: 're.LiteralChars',
  66: 're.Token',
  67: 're.BracedVarSub',
  68: 're.DoubleQuoted',
  69: 're.SingleQuoted',
  70: 're.SimpleVarSub',
  95: 're.PosixClass',
  96: 're.PerlClass',
}

def re_str(tag):
  # type: (int) -> str
  return _re_str[tag]

class re_t(pybase.CompoundObj):
  def tag_(self):
    # type: () -> int
    return self._type_tag
  pass

class re__CharClassLiteral(re_t):
  _type_tag = 4
  __slots__ = ('negated', 'terms')

  def __init__(self, negated, terms):
    # type: (bool, Optional[List[class_literal_term_t]]) -> None
    self.negated = negated
    self.terms = terms

  @staticmethod
  def Create():
    # type: () -> re__CharClassLiteral
    return re__CharClassLiteral(False, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.CharClassLiteral')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.terms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.terms:
        x1.children.append(i1.PrettyTree())
      L.append(field('terms', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.CharClassLiteral')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.terms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.terms:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('terms', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__CharClass(re_t):
  _type_tag = 5
  __slots__ = ('negated', 'terms')

  def __init__(self, negated, terms):
    # type: (bool, Optional[List[char_class_term_t]]) -> None
    self.negated = negated
    self.terms = terms

  @staticmethod
  def Create():
    # type: () -> re__CharClass
    return re__CharClass(False, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.CharClass')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.terms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.terms:
        x1.children.append(i1.PrettyTree())
      L.append(field('terms', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.CharClass')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    if self.terms is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.terms:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('terms', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Splice(re_t):
  _type_tag = 6
  __slots__ = ('name', 'var_name')

  def __init__(self, name, var_name):
    # type: (Optional[Token], str) -> None
    self.name = name
    self.var_name = var_name

  @staticmethod
  def Create():
    # type: () -> re__Splice
    return re__Splice(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Splice')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Splice')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Repeat(re_t):
  _type_tag = 11
  __slots__ = ('child', 'op')

  def __init__(self, child, op):
    # type: (Optional[re_t], Optional[re_repeat_t]) -> None
    self.child = child
    self.op = op

  @staticmethod
  def Create():
    # type: () -> re__Repeat
    return re__Repeat(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Repeat')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    assert self.op is not None
    x1 = self.op.PrettyTree()
    L.append(field('op', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Repeat')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    assert self.op is not None
    x1 = self.op.AbbreviatedTree()
    L.append(field('op', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Seq(re_t):
  _type_tag = 12
  __slots__ = ('children',)

  def __init__(self, children):
    # type: (Optional[List[re_t]]) -> None
    self.children = children

  @staticmethod
  def Create():
    # type: () -> re__Seq
    return re__Seq([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Seq')
    L = out_node.fields

    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.PrettyTree())
      L.append(field('children', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Seq')
    L = out_node.fields
    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('children', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Alt(re_t):
  _type_tag = 13
  __slots__ = ('children',)

  def __init__(self, children):
    # type: (Optional[List[re_t]]) -> None
    self.children = children

  @staticmethod
  def Create():
    # type: () -> re__Alt
    return re__Alt([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Alt')
    L = out_node.fields

    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.PrettyTree())
      L.append(field('children', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Alt')
    L = out_node.fields
    if self.children is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.children:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('children', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Group(re_t):
  _type_tag = 14
  __slots__ = ('child',)

  def __init__(self, child):
    # type: (Optional[re_t]) -> None
    self.child = child

  @staticmethod
  def Create():
    # type: () -> re__Group
    return re__Group(None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Group')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Group')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Capture(re_t):
  _type_tag = 15
  __slots__ = ('child', 'var_name')

  def __init__(self, child, var_name):
    # type: (Optional[re_t], Optional[Optional[Token]]) -> None
    self.child = child
    self.var_name = var_name

  @staticmethod
  def Create():
    # type: () -> re__Capture
    return re__Capture(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Capture')
    L = out_node.fields

    assert self.child is not None
    x0 = self.child.PrettyTree()
    L.append(field('child', x0))

    if self.var_name is not None:  # maybe
      x1 = self.var_name.PrettyTree()
      L.append(field('var_name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Capture')
    L = out_node.fields
    assert self.child is not None
    x0 = self.child.AbbreviatedTree()
    L.append(field('child', x0))

    if self.var_name is not None:  # maybe
      x1 = self.var_name.AbbreviatedTree()
      L.append(field('var_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Backtracking(re_t):
  _type_tag = 16
  __slots__ = ('negated', 'name', 'child')

  def __init__(self, negated, name, child):
    # type: (bool, Optional[Token], Optional[re_t]) -> None
    self.negated = negated
    self.name = name
    self.child = child

  @staticmethod
  def Create():
    # type: () -> re__Backtracking
    return re__Backtracking(False, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Backtracking')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    assert self.name is not None
    x1 = self.name.PrettyTree()
    L.append(field('name', x1))

    assert self.child is not None
    x2 = self.child.PrettyTree()
    L.append(field('child', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Backtracking')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
    L.append(field('negated', x0))

    assert self.name is not None
    x1 = self.name.AbbreviatedTree()
    L.append(field('name', x1))

    assert self.child is not None
    x2 = self.child.AbbreviatedTree()
    L.append(field('child', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__Primitive(re_t):
  _type_tag = 17
  __slots__ = ('id',)

  def __init__(self, id):
    # type: (Id_t) -> None
    self.id = id

  @staticmethod
  def Create():
    # type: () -> re__Primitive
    return re__Primitive(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Primitive')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.Primitive')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re__LiteralChars(re_t):
  _type_tag = 18
  __slots__ = ('s', 'spid')

  def __init__(self, s, spid):
    # type: (str, int) -> None
    self.s = s
    self.spid = spid

  @staticmethod
  def Create():
    # type: () -> re__LiteralChars
    return re__LiteralChars('', -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.LiteralChars')
    L = out_node.fields

    x0 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x0))

    x1 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('re.LiteralChars')
    L = out_node.fields
    x0 = NewLeaf(self.s, color_e.StringConst)
    L.append(field('s', x0))

    x1 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class re(object):
  CharClassLiteral = re__CharClassLiteral
  CharClass = re__CharClass
  Splice = re__Splice
  Repeat = re__Repeat
  Seq = re__Seq
  Alt = re__Alt
  Group = re__Group
  Capture = re__Capture
  Backtracking = re__Backtracking
  Primitive = re__Primitive
  LiteralChars = re__LiteralChars

class BoolOutParam(pybase.CompoundObj):
  _type_tag = 64
  __slots__ = ('b',)

  def __init__(self, b):
    # type: (bool) -> None
    self.b = b

  @staticmethod
  def Create():
    # type: () -> BoolOutParam
    return BoolOutParam(False)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BoolOutParam')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.b else 'F', color_e.OtherConst)
    L.append(field('b', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BoolOutParam')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.b else 'F', color_e.OtherConst)
    L.append(field('b', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class SourceLine(pybase.CompoundObj):
  _type_tag = 65
  __slots__ = ('line_num', 'content', 'src')

  def __init__(self, line_num, content, src):
    # type: (int, str, Optional[source_t]) -> None
    self.line_num = line_num
    self.content = content
    self.src = src

  @staticmethod
  def Create():
    # type: () -> SourceLine
    return SourceLine(-1, '', None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SourceLine')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.line_num), color_e.OtherConst)
    L.append(field('line_num', x0))

    x1 = NewLeaf(self.content, color_e.StringConst)
    L.append(field('content', x1))

    assert self.src is not None
    x2 = self.src.PrettyTree()
    L.append(field('src', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SourceLine')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.line_num), color_e.OtherConst)
    L.append(field('line_num', x0))

    x1 = NewLeaf(self.content, color_e.StringConst)
    L.append(field('content', x1))

    assert self.src is not None
    x2 = self.src.AbbreviatedTree()
    L.append(field('src', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Token(loc_t, suffix_op_t, word_part_t, word_t, re_t):
  _type_tag = 66
  __slots__ = ('id', 'col', 'length', 'span_id', 'line', 'tval')

  def __init__(self, id, col, length, span_id, line, tval):
    # type: (Id_t, int, int, int, Optional[Optional[SourceLine]], str) -> None
    self.id = id
    self.col = col
    self.length = length
    self.span_id = span_id
    self.line = line
    self.tval = tval

  @staticmethod
  def Create():
    # type: () -> Token
    return Token(-1, -1, -1, -1, None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Token')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = hnode.Leaf(str(self.col), color_e.OtherConst)
    L.append(field('col', x1))

    x2 = hnode.Leaf(str(self.length), color_e.OtherConst)
    L.append(field('length', x2))

    x3 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x3))

    if self.line is not None:  # maybe
      x4 = self.line.PrettyTree()
      L.append(field('line', x4))

    x5 = NewLeaf(self.tval, color_e.StringConst)
    L.append(field('tval', x5))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Token')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(field('id', x0))

    x1 = hnode.Leaf(str(self.col), color_e.OtherConst)
    L.append(field('col', x1))

    x2 = hnode.Leaf(str(self.length), color_e.OtherConst)
    L.append(field('length', x2))

    x3 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(field('span_id', x3))

    if self.line is not None:  # maybe
      x4 = self.line.AbbreviatedTree()
      L.append(field('line', x4))

    x5 = NewLeaf(self.tval, color_e.StringConst)
    L.append(field('tval', x5))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _Token(self)
    return p if p else self._AbbreviatedTree()

class braced_var_sub(word_part_t, expr_t, class_literal_term_t, re_t):
  _type_tag = 67
  __slots__ = ('left', 'token', 'var_name', 'prefix_op', 'bracket_op',
               'suffix_op', 'right')

  def __init__(self, left, token, var_name, prefix_op, bracket_op, suffix_op,
               right):
    # type: (Optional[Token], Optional[Token], str, Optional[Optional[Token]], Optional[Optional[bracket_op_t]], Optional[Optional[suffix_op_t]], Optional[Token]) -> None
    self.left = left
    self.token = token
    self.var_name = var_name
    self.prefix_op = prefix_op
    self.bracket_op = bracket_op
    self.suffix_op = suffix_op
    self.right = right

  @staticmethod
  def Create():
    # type: () -> braced_var_sub
    return braced_var_sub(None, None, '', None, None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('braced_var_sub')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    assert self.token is not None
    x1 = self.token.PrettyTree()
    L.append(field('token', x1))

    x2 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x2))

    if self.prefix_op is not None:  # maybe
      x3 = self.prefix_op.PrettyTree()
      L.append(field('prefix_op', x3))

    if self.bracket_op is not None:  # maybe
      x4 = self.bracket_op.PrettyTree()
      L.append(field('bracket_op', x4))

    if self.suffix_op is not None:  # maybe
      x5 = self.suffix_op.PrettyTree()
      L.append(field('suffix_op', x5))

    assert self.right is not None
    x6 = self.right.PrettyTree()
    L.append(field('right', x6))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('braced_var_sub')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    assert self.token is not None
    x1 = self.token.AbbreviatedTree()
    L.append(field('token', x1))

    x2 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x2))

    if self.prefix_op is not None:  # maybe
      x3 = self.prefix_op.AbbreviatedTree()
      L.append(field('prefix_op', x3))

    if self.bracket_op is not None:  # maybe
      x4 = self.bracket_op.AbbreviatedTree()
      L.append(field('bracket_op', x4))

    if self.suffix_op is not None:  # maybe
      x5 = self.suffix_op.AbbreviatedTree()
      L.append(field('suffix_op', x5))

    assert self.right is not None
    x6 = self.right.AbbreviatedTree()
    L.append(field('right', x6))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _braced_var_sub(self)
    return p if p else self._AbbreviatedTree()

class double_quoted(word_part_t, expr_t, class_literal_term_t, re_t):
  _type_tag = 68
  __slots__ = ('left', 'parts', 'right')

  def __init__(self, left, parts, right):
    # type: (Optional[Token], Optional[List[word_part_t]], Optional[Token]) -> None
    self.left = left
    self.parts = parts
    self.right = right

  @staticmethod
  def Create():
    # type: () -> double_quoted
    return double_quoted(None, [], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('double_quoted')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.parts is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.parts:
        x1.children.append(i1.PrettyTree())
      L.append(field('parts', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('double_quoted')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.parts is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.parts:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('parts', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _double_quoted(self)
    return p if p else self._AbbreviatedTree()

class single_quoted(word_part_t, expr_t, class_literal_term_t, re_t):
  _type_tag = 69
  __slots__ = ('left', 'tokens', 'right')

  def __init__(self, left, tokens, right):
    # type: (Optional[Token], Optional[List[Token]], Optional[Token]) -> None
    self.left = left
    self.tokens = tokens
    self.right = right

  @staticmethod
  def Create():
    # type: () -> single_quoted
    return single_quoted(None, [], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('single_quoted')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.tokens is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.tokens:
        x1.children.append(i1.PrettyTree())
      L.append(field('tokens', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('single_quoted')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.tokens is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.tokens:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('tokens', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _single_quoted(self)
    return p if p else self._AbbreviatedTree()

class simple_var_sub(word_part_t, arith_expr_t, expr_t, class_literal_term_t,
                     re_t):
  _type_tag = 70
  __slots__ = ('left', 'var_name')

  def __init__(self, left, var_name):
    # type: (Optional[Token], str) -> None
    self.left = left
    self.var_name = var_name

  @staticmethod
  def Create():
    # type: () -> simple_var_sub
    return simple_var_sub(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('simple_var_sub')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('simple_var_sub')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(field('var_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _simple_var_sub(self)
    return p if p else self._AbbreviatedTree()

class command_sub(word_part_t, expr_t):
  _type_tag = 71
  __slots__ = ('left_token', 'child', 'right')

  def __init__(self, left_token, child, right):
    # type: (Optional[Token], Optional[command_t], Optional[Token]) -> None
    self.left_token = left_token
    self.child = child
    self.right = right

  @staticmethod
  def Create():
    # type: () -> command_sub
    return command_sub(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command_sub')
    L = out_node.fields

    assert self.left_token is not None
    x0 = self.left_token.PrettyTree()
    L.append(field('left_token', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(field('child', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command_sub')
    L = out_node.fields
    assert self.left_token is not None
    x0 = self.left_token.AbbreviatedTree()
    L.append(field('left_token', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(field('child', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class sh_array_literal(word_part_t, expr_t):
  _type_tag = 72
  __slots__ = ('left', 'words')

  def __init__(self, left, words):
    # type: (Optional[Token], Optional[List[word_t]]) -> None
    self.left = left
    self.words = words

  @staticmethod
  def Create():
    # type: () -> sh_array_literal
    return sh_array_literal(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_array_literal')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.words is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.words:
        x1.children.append(i1.PrettyTree())
      L.append(field('words', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('sh_array_literal')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.words is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.words:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('words', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class ArgList(pybase.CompoundObj):
  _type_tag = 73
  __slots__ = ('left', 'positional', 'named', 'right')

  def __init__(self, left, positional, named, right):
    # type: (Optional[Token], Optional[List[expr_t]], Optional[List[named_arg]], Optional[Token]) -> None
    self.left = left
    self.positional = positional
    self.named = named
    self.right = right

  @staticmethod
  def Create():
    # type: () -> ArgList
    return ArgList(None, [], [], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ArgList')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.positional is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.positional:
        x1.children.append(i1.PrettyTree())
      L.append(field('positional', x1))

    if self.named is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.named:
        x2.children.append(i2.PrettyTree())
      L.append(field('named', x2))

    assert self.right is not None
    x3 = self.right.PrettyTree()
    L.append(field('right', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ArgList')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.positional is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.positional:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('positional', x1))

    if self.named is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.named:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('named', x2))

    assert self.right is not None
    x3 = self.right.AbbreviatedTree()
    L.append(field('right', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class assoc_pair(pybase.CompoundObj):
  _type_tag = 74
  __slots__ = ('key', 'value')

  def __init__(self, key, value):
    # type: (Optional[compound_word], Optional[compound_word]) -> None
    self.key = key
    self.value = value

  @staticmethod
  def Create():
    # type: () -> assoc_pair
    return assoc_pair(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('assoc_pair')
    L = out_node.fields

    assert self.key is not None
    x0 = self.key.PrettyTree()
    L.append(field('key', x0))

    assert self.value is not None
    x1 = self.value.PrettyTree()
    L.append(field('value', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('assoc_pair')
    L = out_node.fields
    assert self.key is not None
    x0 = self.key.AbbreviatedTree()
    L.append(field('key', x0))

    assert self.value is not None
    x1 = self.value.AbbreviatedTree()
    L.append(field('value', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class compound_word(rhs_word_t, word_t, arith_expr_t, redir_param_t):
  _type_tag = 75
  __slots__ = ('parts',)

  def __init__(self, parts):
    # type: (Optional[List[word_part_t]]) -> None
    self.parts = parts

  @staticmethod
  def Create():
    # type: () -> compound_word
    return compound_word([])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('compound_word')
    L = out_node.fields

    if self.parts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.PrettyTree())
      L.append(field('parts', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('compound_word')
    L = out_node.fields
    if self.parts is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('parts', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _compound_word(self)
    return p if p else self._AbbreviatedTree()

class string_line(pybase.CompoundObj):
  _type_tag = 76
  __slots__ = ('dedent', 'part')

  def __init__(self, dedent, part):
    # type: (int, Optional[List[word_part_t]]) -> None
    self.dedent = dedent
    self.part = part

  @staticmethod
  def Create():
    # type: () -> string_line
    return string_line(-1, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('string_line')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.dedent), color_e.OtherConst)
    L.append(field('dedent', x0))

    if self.part is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.part:
        x1.children.append(i1.PrettyTree())
      L.append(field('part', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('string_line')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.dedent), color_e.OtherConst)
    L.append(field('dedent', x0))

    if self.part is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.part:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('part', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class triple_quoted(pybase.CompoundObj):
  _type_tag = 77
  __slots__ = ('min_dedent', 'lines')

  def __init__(self, min_dedent, lines):
    # type: (int, Optional[List[string_line]]) -> None
    self.min_dedent = min_dedent
    self.lines = lines

  @staticmethod
  def Create():
    # type: () -> triple_quoted
    return triple_quoted(-1, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('triple_quoted')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.min_dedent), color_e.OtherConst)
    L.append(field('min_dedent', x0))

    if self.lines is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.PrettyTree())
      L.append(field('lines', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('triple_quoted')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.min_dedent), color_e.OtherConst)
    L.append(field('min_dedent', x0))

    if self.lines is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('lines', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class redir(pybase.CompoundObj):
  _type_tag = 78
  __slots__ = ('op', 'loc', 'arg')

  def __init__(self, op, loc, arg):
    # type: (Optional[Token], Optional[redir_loc_t], Optional[redir_param_t]) -> None
    self.op = op
    self.loc = loc
    self.arg = arg

  @staticmethod
  def Create():
    # type: () -> redir
    return redir(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(field('op', x0))

    assert self.loc is not None
    x1 = self.loc.PrettyTree()
    L.append(field('loc', x1))

    assert self.arg is not None
    x2 = self.arg.PrettyTree()
    L.append(field('arg', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('redir')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(field('op', x0))

    assert self.loc is not None
    x1 = self.loc.AbbreviatedTree()
    L.append(field('loc', x1))

    assert self.arg is not None
    x2 = self.arg.AbbreviatedTree()
    L.append(field('arg', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class assign_pair(pybase.CompoundObj):
  _type_tag = 79
  __slots__ = ('lhs', 'op', 'rhs', 'spids')

  def __init__(self, lhs, op, rhs, spids):
    # type: (Optional[sh_lhs_expr_t], assign_op_t, Optional[rhs_word_t], Optional[List[int]]) -> None
    self.lhs = lhs
    self.op = op
    self.rhs = rhs
    self.spids = spids

  @staticmethod
  def Create():
    # type: () -> assign_pair
    return assign_pair(None, assign_op_e.Equal, None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('assign_pair')
    L = out_node.fields

    assert self.lhs is not None
    x0 = self.lhs.PrettyTree()
    L.append(field('lhs', x0))

    x1 = hnode.Leaf(assign_op_str(self.op), color_e.TypeName)
    L.append(field('op', x1))

    assert self.rhs is not None
    x2 = self.rhs.PrettyTree()
    L.append(field('rhs', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('assign_pair')
    L = out_node.fields
    assert self.lhs is not None
    x0 = self.lhs.AbbreviatedTree()
    L.append(field('lhs', x0))

    x1 = hnode.Leaf(assign_op_str(self.op), color_e.TypeName)
    L.append(field('op', x1))

    assert self.rhs is not None
    x2 = self.rhs.AbbreviatedTree()
    L.append(field('rhs', x2))

    if self.spids is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.spids:
        x3.children.append(hnode.Leaf(str(i3), color_e.OtherConst))
      L.append(field('spids', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class env_pair(pybase.CompoundObj):
  _type_tag = 80
  __slots__ = ('name', 'val', 'spids')

  def __init__(self, name, val, spids):
    # type: (str, Optional[rhs_word_t], Optional[List[int]]) -> None
    self.name = name
    self.val = val
    self.spids = spids

  @staticmethod
  def Create():
    # type: () -> env_pair
    return env_pair('', None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('env_pair')
    L = out_node.fields

    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    assert self.val is not None
    x1 = self.val.PrettyTree()
    L.append(field('val', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('env_pair')
    L = out_node.fields
    x0 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x0))

    assert self.val is not None
    x1 = self.val.AbbreviatedTree()
    L.append(field('val', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class case_arm(pybase.CompoundObj):
  _type_tag = 81
  __slots__ = ('pat_list', 'action', 'spids')

  def __init__(self, pat_list, action, spids):
    # type: (Optional[List[word_t]], Optional[List[command_t]], Optional[List[int]]) -> None
    self.pat_list = pat_list
    self.action = action
    self.spids = spids

  @staticmethod
  def Create():
    # type: () -> case_arm
    return case_arm([], [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('case_arm')
    L = out_node.fields

    if self.pat_list is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.pat_list:
        x0.children.append(i0.PrettyTree())
      L.append(field('pat_list', x0))

    if self.action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.action:
        x1.children.append(i1.PrettyTree())
      L.append(field('action', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('case_arm')
    L = out_node.fields
    if self.pat_list is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.pat_list:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('pat_list', x0))

    if self.action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.action:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('action', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class if_arm(pybase.CompoundObj):
  _type_tag = 82
  __slots__ = ('cond', 'action', 'spids')

  def __init__(self, cond, action, spids):
    # type: (Optional[condition_t], Optional[List[command_t]], Optional[List[int]]) -> None
    self.cond = cond
    self.action = action
    self.spids = spids

  @staticmethod
  def Create():
    # type: () -> if_arm
    return if_arm(None, [], [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('if_arm')
    L = out_node.fields

    assert self.cond is not None
    x0 = self.cond.PrettyTree()
    L.append(field('cond', x0))

    if self.action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.action:
        x1.children.append(i1.PrettyTree())
      L.append(field('action', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('if_arm')
    L = out_node.fields
    assert self.cond is not None
    x0 = self.cond.AbbreviatedTree()
    L.append(field('cond', x0))

    if self.action is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.action:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('action', x1))

    if self.spids is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.spids:
        x2.children.append(hnode.Leaf(str(i2), color_e.OtherConst))
      L.append(field('spids', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class BraceGroup(command_t):
  _type_tag = 83
  __slots__ = ('left', 'doc_token', 'children', 'redirects', 'right')

  def __init__(self, left, doc_token, children, redirects, right):
    # type: (Optional[Token], Optional[Optional[Token]], Optional[List[command_t]], Optional[List[redir]], Optional[Token]) -> None
    self.left = left
    self.doc_token = doc_token
    self.children = children
    self.redirects = redirects
    self.right = right

  @staticmethod
  def Create():
    # type: () -> BraceGroup
    return BraceGroup(None, None, [], [], None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BraceGroup')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(field('left', x0))

    if self.doc_token is not None:  # maybe
      x1 = self.doc_token.PrettyTree()
      L.append(field('doc_token', x1))

    if self.children is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.children:
        x2.children.append(i2.PrettyTree())
      L.append(field('children', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.PrettyTree())
      L.append(field('redirects', x3))

    assert self.right is not None
    x4 = self.right.PrettyTree()
    L.append(field('right', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BraceGroup')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(field('left', x0))

    if self.doc_token is not None:  # maybe
      x1 = self.doc_token.AbbreviatedTree()
      L.append(field('doc_token', x1))

    if self.children is not None:  # array
      x2 = hnode.Array([])
      for i2 in self.children:
        x2.children.append(i2.AbbreviatedTree())
      L.append(field('children', x2))

    if self.redirects is not None:  # array
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.AbbreviatedTree())
      L.append(field('redirects', x3))

    assert self.right is not None
    x4 = self.right.AbbreviatedTree()
    L.append(field('right', x4))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class BlockArg(expr_t):
  _type_tag = 84
  __slots__ = ('brace_group', 'lines')

  def __init__(self, brace_group, lines):
    # type: (Optional[BraceGroup], Optional[List[SourceLine]]) -> None
    self.brace_group = brace_group
    self.lines = lines

  @staticmethod
  def Create():
    # type: () -> BlockArg
    return BlockArg(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BlockArg')
    L = out_node.fields

    assert self.brace_group is not None
    x0 = self.brace_group.PrettyTree()
    L.append(field('brace_group', x0))

    if self.lines is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.PrettyTree())
      L.append(field('lines', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BlockArg')
    L = out_node.fields
    assert self.brace_group is not None
    x0 = self.brace_group.AbbreviatedTree()
    L.append(field('brace_group', x0))

    if self.lines is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('lines', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class variant(pybase.CompoundObj):
  _type_tag = 85
  __slots__ = ('tag_name', 'typ')

  def __init__(self, tag_name, typ):
    # type: (Optional[Token], Optional[Optional[variant_type_t]]) -> None
    self.tag_name = tag_name
    self.typ = typ

  @staticmethod
  def Create():
    # type: () -> variant
    return variant(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant')
    L = out_node.fields

    assert self.tag_name is not None
    x0 = self.tag_name.PrettyTree()
    L.append(field('tag_name', x0))

    if self.typ is not None:  # maybe
      x1 = self.typ.PrettyTree()
      L.append(field('typ', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('variant')
    L = out_node.fields
    assert self.tag_name is not None
    x0 = self.tag_name.AbbreviatedTree()
    L.append(field('tag_name', x0))

    if self.typ is not None:  # maybe
      x1 = self.typ.AbbreviatedTree()
      L.append(field('typ', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class import_name(pybase.CompoundObj):
  _type_tag = 86
  __slots__ = ('name', 'alias')

  def __init__(self, name, alias):
    # type: (Optional[Token], Optional[Optional[Token]]) -> None
    self.name = name
    self.alias = alias

  @staticmethod
  def Create():
    # type: () -> import_name
    return import_name(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('import_name')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.alias is not None:  # maybe
      x1 = self.alias.PrettyTree()
      L.append(field('alias', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('import_name')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.alias is not None:  # maybe
      x1 = self.alias.AbbreviatedTree()
      L.append(field('alias', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class UntypedParam(pybase.CompoundObj):
  _type_tag = 87
  __slots__ = ('ref', 'name', 'default_val')

  def __init__(self, ref, name, default_val):
    # type: (Optional[Optional[Token]], Optional[Token], Optional[Optional[expr_t]]) -> None
    self.ref = ref
    self.name = name
    self.default_val = default_val

  @staticmethod
  def Create():
    # type: () -> UntypedParam
    return UntypedParam(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('UntypedParam')
    L = out_node.fields

    if self.ref is not None:  # maybe
      x0 = self.ref.PrettyTree()
      L.append(field('ref', x0))

    assert self.name is not None
    x1 = self.name.PrettyTree()
    L.append(field('name', x1))

    if self.default_val is not None:  # maybe
      x2 = self.default_val.PrettyTree()
      L.append(field('default_val', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('UntypedParam')
    L = out_node.fields
    if self.ref is not None:  # maybe
      x0 = self.ref.AbbreviatedTree()
      L.append(field('ref', x0))

    assert self.name is not None
    x1 = self.name.AbbreviatedTree()
    L.append(field('name', x1))

    if self.default_val is not None:  # maybe
      x2 = self.default_val.AbbreviatedTree()
      L.append(field('default_val', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class TypedParam(pybase.CompoundObj):
  _type_tag = 88
  __slots__ = ('name', 'type', 'default_val')

  def __init__(self, name, type, default_val):
    # type: (Optional[Token], Optional[Token], Optional[Optional[expr_t]]) -> None
    self.name = name
    self.type = type
    self.default_val = default_val

  @staticmethod
  def Create():
    # type: () -> TypedParam
    return TypedParam(None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('TypedParam')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    assert self.type is not None
    x1 = self.type.PrettyTree()
    L.append(field('type', x1))

    if self.default_val is not None:  # maybe
      x2 = self.default_val.PrettyTree()
      L.append(field('default_val', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('TypedParam')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    assert self.type is not None
    x1 = self.type.AbbreviatedTree()
    L.append(field('type', x1))

    if self.default_val is not None:  # maybe
      x2 = self.default_val.AbbreviatedTree()
      L.append(field('default_val', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class param(pybase.CompoundObj):
  _type_tag = 89
  __slots__ = ('prefix', 'name', 'type', 'default_val')

  def __init__(self, prefix, name, type, default_val):
    # type: (Optional[Optional[Token]], Optional[Token], Optional[Optional[type_expr_t]], Optional[Optional[expr_t]]) -> None
    self.prefix = prefix
    self.name = name
    self.type = type
    self.default_val = default_val

  @staticmethod
  def Create():
    # type: () -> param
    return param(None, None, None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('param')
    L = out_node.fields

    if self.prefix is not None:  # maybe
      x0 = self.prefix.PrettyTree()
      L.append(field('prefix', x0))

    assert self.name is not None
    x1 = self.name.PrettyTree()
    L.append(field('name', x1))

    if self.type is not None:  # maybe
      x2 = self.type.PrettyTree()
      L.append(field('type', x2))

    if self.default_val is not None:  # maybe
      x3 = self.default_val.PrettyTree()
      L.append(field('default_val', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('param')
    L = out_node.fields
    if self.prefix is not None:  # maybe
      x0 = self.prefix.AbbreviatedTree()
      L.append(field('prefix', x0))

    assert self.name is not None
    x1 = self.name.AbbreviatedTree()
    L.append(field('name', x1))

    if self.type is not None:  # maybe
      x2 = self.type.AbbreviatedTree()
      L.append(field('type', x2))

    if self.default_val is not None:  # maybe
      x3 = self.default_val.AbbreviatedTree()
      L.append(field('default_val', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class name_type(pybase.CompoundObj):
  _type_tag = 90
  __slots__ = ('name', 'typ')

  def __init__(self, name, typ):
    # type: (Optional[Token], Optional[Optional[type_expr_t]]) -> None
    self.name = name
    self.typ = typ

  @staticmethod
  def Create():
    # type: () -> name_type
    return name_type(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('name_type')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(field('name', x0))

    if self.typ is not None:  # maybe
      x1 = self.typ.PrettyTree()
      L.append(field('typ', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('name_type')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(field('name', x0))

    if self.typ is not None:  # maybe
      x1 = self.typ.AbbreviatedTree()
      L.append(field('typ', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class comprehension(pybase.CompoundObj):
  _type_tag = 91
  __slots__ = ('lhs', 'iter', 'cond')

  def __init__(self, lhs, iter, cond):
    # type: (Optional[List[name_type]], Optional[expr_t], Optional[Optional[expr_t]]) -> None
    self.lhs = lhs
    self.iter = iter
    self.cond = cond

  @staticmethod
  def Create():
    # type: () -> comprehension
    return comprehension([], None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('comprehension')
    L = out_node.fields

    if self.lhs is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.lhs:
        x0.children.append(i0.PrettyTree())
      L.append(field('lhs', x0))

    assert self.iter is not None
    x1 = self.iter.PrettyTree()
    L.append(field('iter', x1))

    if self.cond is not None:  # maybe
      x2 = self.cond.PrettyTree()
      L.append(field('cond', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('comprehension')
    L = out_node.fields
    if self.lhs is not None:  # array
      x0 = hnode.Array([])
      for i0 in self.lhs:
        x0.children.append(i0.AbbreviatedTree())
      L.append(field('lhs', x0))

    assert self.iter is not None
    x1 = self.iter.AbbreviatedTree()
    L.append(field('iter', x1))

    if self.cond is not None:  # maybe
      x2 = self.cond.AbbreviatedTree()
      L.append(field('cond', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class named_arg(pybase.CompoundObj):
  _type_tag = 92
  __slots__ = ('name', 'value')

  def __init__(self, name, value):
    # type: (Optional[Optional[Token]], Optional[expr_t]) -> None
    self.name = name
    self.value = value

  @staticmethod
  def Create():
    # type: () -> named_arg
    return named_arg(None, None)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('named_arg')
    L = out_node.fields

    if self.name is not None:  # maybe
      x0 = self.name.PrettyTree()
      L.append(field('name', x0))

    assert self.value is not None
    x1 = self.value.PrettyTree()
    L.append(field('value', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('named_arg')
    L = out_node.fields
    if self.name is not None:  # maybe
      x0 = self.name.AbbreviatedTree()
      L.append(field('name', x0))

    assert self.value is not None
    x1 = self.value.AbbreviatedTree()
    L.append(field('value', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class subscript(place_expr_t, expr_t):
  _type_tag = 93
  __slots__ = ('obj', 'indices')

  def __init__(self, obj, indices):
    # type: (Optional[expr_t], Optional[List[expr_t]]) -> None
    self.obj = obj
    self.indices = indices

  @staticmethod
  def Create():
    # type: () -> subscript
    return subscript(None, [])

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('subscript')
    L = out_node.fields

    assert self.obj is not None
    x0 = self.obj.PrettyTree()
    L.append(field('obj', x0))

    if self.indices is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.indices:
        x1.children.append(i1.PrettyTree())
      L.append(field('indices', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('subscript')
    L = out_node.fields
    assert self.obj is not None
    x0 = self.obj.AbbreviatedTree()
    L.append(field('obj', x0))

    if self.indices is not None:  # array
      x1 = hnode.Array([])
      for i1 in self.indices:
        x1.children.append(i1.AbbreviatedTree())
      L.append(field('indices', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class attribute(place_expr_t, expr_t):
  _type_tag = 94
  __slots__ = ('obj', 'op', 'attr', 'ctx')

  def __init__(self, obj, op, attr, ctx):
    # type: (Optional[expr_t], Optional[Token], Optional[Token], expr_context_t) -> None
    self.obj = obj
    self.op = op
    self.attr = attr
    self.ctx = ctx

  @staticmethod
  def Create():
    # type: () -> attribute
    return attribute(None, None, None, expr_context_e.Load)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('attribute')
    L = out_node.fields

    assert self.obj is not None
    x0 = self.obj.PrettyTree()
    L.append(field('obj', x0))

    assert self.op is not None
    x1 = self.op.PrettyTree()
    L.append(field('op', x1))

    assert self.attr is not None
    x2 = self.attr.PrettyTree()
    L.append(field('attr', x2))

    x3 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('attribute')
    L = out_node.fields
    assert self.obj is not None
    x0 = self.obj.AbbreviatedTree()
    L.append(field('obj', x0))

    assert self.op is not None
    x1 = self.op.AbbreviatedTree()
    L.append(field('op', x1))

    assert self.attr is not None
    x2 = self.attr.AbbreviatedTree()
    L.append(field('attr', x2))

    x3 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(field('ctx', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class posix_class(class_literal_term_t, char_class_term_t, re_t):
  _type_tag = 95
  __slots__ = ('negated', 'name')

  def __init__(self, negated, name):
    # type: (Optional[Optional[Token]], str) -> None
    self.negated = negated
    self.name = name

  @staticmethod
  def Create():
    # type: () -> posix_class
    return posix_class(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('posix_class')
    L = out_node.fields

    if self.negated is not None:  # maybe
      x0 = self.negated.PrettyTree()
      L.append(field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('posix_class')
    L = out_node.fields
    if self.negated is not None:  # maybe
      x0 = self.negated.AbbreviatedTree()
      L.append(field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class perl_class(class_literal_term_t, char_class_term_t, re_t):
  _type_tag = 96
  __slots__ = ('negated', 'name')

  def __init__(self, negated, name):
    # type: (Optional[Optional[Token]], str) -> None
    self.negated = negated
    self.name = name

  @staticmethod
  def Create():
    # type: () -> perl_class
    return perl_class(None, '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('perl_class')
    L = out_node.fields

    if self.negated is not None:  # maybe
      x0 = self.negated.PrettyTree()
      L.append(field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('perl_class')
    L = out_node.fields
    if self.negated is not None:  # maybe
      x0 = self.negated.AbbreviatedTree()
      L.append(field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class CharCode(char_class_term_t):
  _type_tag = 97
  __slots__ = ('i', 'u_braced', 'spid')

  def __init__(self, i, u_braced, spid):
    # type: (int, bool, int) -> None
    self.i = i
    self.u_braced = u_braced
    self.spid = spid

  @staticmethod
  def Create():
    # type: () -> CharCode
    return CharCode(-1, False, -1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CharCode')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(field('i', x0))

    x1 = hnode.Leaf('T' if self.u_braced else 'F', color_e.OtherConst)
    L.append(field('u_braced', x1))

    x2 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CharCode')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(field('i', x0))

    x1 = hnode.Leaf('T' if self.u_braced else 'F', color_e.OtherConst)
    L.append(field('u_braced', x1))

    x2 = hnode.Leaf(str(self.spid), color_e.OtherConst)
    L.append(field('spid', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

#
# CONCATENATED FILE
#

"""
syntax_abbrev.py - Abbreviations for pretty-printing syntax.asdl.

This module is not used directly, but is combined with generated code.
"""

from _devbuild.gen.id_kind_asdl import Id
from _devbuild.gen.hnode_asdl import hnode_t
from asdl import runtime


def _AbbreviateToken(tok, out):
  # type: (Token, List[hnode_t]) -> None
  if tok.id != Id.Lit_Chars:
    n1 = runtime.NewLeaf(Id_str(tok.id), color_e.OtherConst)
    out.append(n1)

  n2 = runtime.NewLeaf(tok.tval, color_e.StringConst)
  out.append(n2)


def _Token(obj):
  # type: (Token) -> hnode_t
  p_node = runtime.NewRecord('')  # don't show node type
  p_node.abbrev = True

  p_node.left = '<'
  p_node.right = '>'
  _AbbreviateToken(obj, p_node.unnamed_fields)
  return p_node


def _compound_word(obj):
  # type: (compound_word) -> hnode_t
  p_node = runtime.NewRecord('')  # don't show node type
  p_node.abbrev = True
  p_node.left = '{'
  p_node.right = '}'

  for part in obj.parts:
    p_node.unnamed_fields.append(part.AbbreviatedTree())
  return p_node


def _double_quoted(obj):
  # type: (double_quoted) -> hnode_t
  if obj.left.id != Id.Left_DoubleQuote:
    return None  # Fall back on obj._AbbreviatedTree()

  p_node = runtime.NewRecord('DQ')
  p_node.abbrev = True

  for part in obj.parts:
    p_node.unnamed_fields.append(part.AbbreviatedTree())
  return p_node


def _single_quoted(obj):
  # type: (single_quoted) -> hnode_t

  # Only abbreviate 'foo', not $'foo\n' or r'foo'
  if obj.left.id != Id.Left_SingleQuote:
    return None  # Fall back on obj._AbbreviatedTree()

  p_node = runtime.NewRecord('SQ')
  p_node.abbrev = True

  for token in obj.tokens:
    p_node.unnamed_fields.append(token.AbbreviatedTree())
  return p_node


def _simple_var_sub(obj):
  # type: (simple_var_sub) -> hnode_t
  p_node = runtime.NewRecord('$')
  p_node.abbrev = True

  if obj.left.id != Id.VSub_Name:
    n1 = runtime.NewLeaf(Id_str(obj.left.id), color_e.OtherConst)
    p_node.unnamed_fields.append(n1)

  n2 = runtime.NewLeaf(obj.var_name, color_e.StringConst)
  p_node.unnamed_fields.append(n2)

  return p_node


def _braced_var_sub(obj):
  # type: (braced_var_sub) -> hnode_t
  p_node = runtime.NewRecord('${')
  if obj.prefix_op or obj.bracket_op or obj.suffix_op:
    return None  # we have other fields to display; don't abbreviate

  p_node.abbrev = True
  _AbbreviateToken(obj.token, p_node.unnamed_fields)
  return p_node


def _command__Simple(obj):
  # type: (command__Simple) -> hnode_t
  p_node = runtime.NewRecord('C')
  if (obj.redirects or
      obj.more_env or
      obj.typed_args or
      obj.block or
      obj.do_fork == False):
    return None  # we have other fields to display; don't abbreviate

  p_node.abbrev = True

  for w in obj.words:
    p_node.unnamed_fields.append(w.AbbreviatedTree())
  return p_node


def _expr__Var(obj):
  # type: (expr__Var) -> hnode_t
  p_node = runtime.NewRecord('Var')
  p_node.abbrev = True

  assert obj.name.id == Id.Expr_Name, obj.name
  n1 = runtime.NewLeaf(obj.name.tval, color_e.StringConst)
  p_node.unnamed_fields.append(n1)
  return p_node


def _expr__Const(obj):
  # type: (expr__Const) -> hnode_t
  p_node = runtime.NewRecord('Const')
  p_node.abbrev = True

  tok = obj.c
  out = p_node.unnamed_fields

  n1 = runtime.NewLeaf(Id_str(tok.id), color_e.OtherConst)
  out.append(n1)

  n2 = runtime.NewLeaf(tok.tval, color_e.StringConst)
  out.append(n2)
  return p_node
